/*************************************************************************
 *                          ACTIVE SILICON LIMITED                      
 *                                                                        
 *  File name   : xpl_inc.h
 *  Project     : ASLexamp main header file
 *  Author      : Mike Harrison, Martin Bone
 *  Systems     : ANSI C, WIN32, X, DOS
 *  Written     : 08-APR-1998
 *  Updated     : 
 *  Version     : 1:00:00                                                     
 *                                                                        
 *  Copyright   : Active Silicon 1998
 **************************************************************************
 * Comments: Header file for OS-dependent GUI operations supporting the 
 *           Snapper example code modules.
 * Assumptions:
 * Revisions:
 */
#if ! defined _XPL_INC_DEFINED
#define _XPL_INC_DEFINED

#if defined _SOLARIS2
#include <unistd.h>
#include <sys/file.h>
#include <termios.h>

#elif defined _LYNXOS
#include <unistd.h>
#include <sys/file.h>
#include <termios.h>
#include <pthread.h>
#include <errno.h>

#elif defined _MACINTOSH
#include <Types.h>
#include <Memory.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <Events.h>
#include <Menus.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <SegLoad.h>
#include <Sound.h>
#include <SIOUX.h>
#if defined __MWERKS__
#include <unistd.h>
#endif
#endif

#if defined _X_GRAPHICS
#if ! defined XK_LATIN1
#define XK_LATIN1
#endif

#if ! defined XK_MISCELLANY
#define XK_MISCELLANY
#endif

#include <X11/keysymdef.h>
#endif


#include <xpl_dbg.h>
#include <xpl_gui.h>
#include <xpl_rev.h>
#include <xpl_sem.h>
#include <xpl_snap.h>
#include <xpl_thrd.h>


struct Info
{
   struct SnapInfo   sSnapInfo;   /* Snapper details - for when a thread runs a snapper each */
   struct GuiInfo    sGuiInfo;    /* Application-oriented details */
   struct SemInfo    sSemInfo;    /* Semaphore info */
   struct ThrdInfo   sThrdInfo;   /* Thread info */
};


#if defined _WINNT || defined _WIN95 || defined _DOS32 || defined _VXWORKS
#define ASL_getch() ( getch() )
#else
#define ASL_getch() 
#endif

#define _UNUSED_VAR(x)  x=x

#endif /* _XPL_INC_DEFINED */
