/*************************************************************************
 *                          ACTIVE SILICON LIMITED                      
 *                                                                        
 *  File name   : xpl_snap.h
 *  Project     : ASLExamp maintained example code base.
 *  Author      : Mike Harrison, Martin Bone
 *  Systems     : ANSI C 
 *  Written     : 6-MAR-1998
 *  Updated     : 
 *  Version     : 1:00:00                                                     
 *                                                                        
 *  Copyright 
 **************************************************************************
 * Comments: 
 * Assumptions:
 * Revisions:
 */
#if ! defined _XPL_SNAP_DEFINED
#define _XPL_SNAP_DEFINED

/* Used to set default handle values */
#define TMG_INVALID_HANDLE TMG_NULL

struct SnapInfo {
   char szFileName[MAX_ERROR_STRING_LENGTH]; /* private space to write filename per thread */
   ui32 hBase;
   ui32 hSnapper;

   ui32 dwSlotNum;             /* Used to track which PCI slot we have attempted if not using BASE_AUTO to assign cards */
   ui32 dwBoardID;
   ui16 wModuleID;

   i16  n16Roi[ASL_SIZE_2D_ROI];
   ui32 dwFrameCount;          /* Used to count number of images acquired */
   ui32 dwFrameBufferNumber;   /* Used in callbacks to record current buffer to acquire image to */
   ui32 dwDisplayBufferNumber; /* Used to record which buffer the display routine is using */
   ui32 dwDisplayCount;        /* Used to count number of images actually displayed */
   ui32 dwDevice;              /* Used to record an index number to a struct ThrdInfo array (normally) */
   ui32 bDroppedFrame;         /* Test for dropped frames in sequence mode */

   /* Callback status functionality */
   Terr teCallbackStatus;     /* Used to determine whether callback found an error*/
   ui32 fCallbackActive;      /* Used to determine whether callback is active */

   /* Timing functionality */
   double dStart;              /* Timing values in decimal seconds */
   double dFinish;

   /* Scatter-gather functionality */
   void* psSGTable;            /* pointer to locked physical memory DMA page table */
   void* pvImageBuffer;        /* pointer to user memory block to use for imaging */
   ui32  dwByteImageBufferSize;/* Store size of image buffer in bytes */
};

/* Functions defined as macros to order access to variables */
#define SNAP_CallbackGetActive( sSnap )              ( sSnap.fCallbackActive )
#define SNAP_CallbackSetActive( sSnap, new_value )   sSnap.fCallbackActive = new_value

#define SNAP_CallbackGetStatus( sSnap )              ( sSnap.teCallbackStatus )
#define SNAP_CallbackSetStatus( sSnap, new_value )   sSnap.teCallbackStatus = new_value

/* return TRUE if finished, false otherwise. */
#define SNAP_FramesFinished( sSnap, target_count, current_count )  ( ( target_count == 0 )? FALSE : ( current_count == target_count )? TRUE : FALSE ) 

#endif
