/*************************************************************************
 *                          ACTIVE SILICON LIMITED                      
 *                                                                        
 *  File name   : Thread.h
 *  Project     : ASLExamp maintained example code base.
 *  Author      : MH
 *  Systems     : ANSI C 
 *  Written     : 6-MAR-1998
 *  Updated     : 
 *  Version     : 1:00:00                                                     
 *                                                                        
 *  Copyright 
 **************************************************************************
 * Comments: 
 * Assumptions:
 * Revisions:
 */
#if ! defined _THRD_DEFINED
#define _THRD_DEFINED

#if defined _WIN95 || defined _WINNT
#define THREAD_RETURN( a )  return (ui32) a 
/* Signal saved parent semaphore & return */
#define THREAD_SIGP_RETURN( a, b )  \
{ \
ASL_Sem_SignalParent( b , 1 );\
return (ui32) a ;   \
}
#define THREAD ui32
#elif defined _LYNXOS || defined _SOLARIS2
#define THREAD_RETURN( a )  return (void*) a
#define THREAD (void*)
#endif

/* Local thread details */
struct ThrdInfo {
#if defined _WINNT || defined _WIN95
   HANDLE hThread;
   ui32 ThrdID;
#elif defined _LYNXOS || defined _SOLARIS2
   pthread_t ptThreadID;
   pthread_attr_t ptaThreadAttr;
   ui32 ThrdID;
#elif defined _MACINTOSH || defined _DOS32
   /* The structure must contain at least one member */
   ui32 dwDummy;
#else
   /*#error 'define a thread id and handle variable for this os'*/
#endif
};

ui32 ASL_Thrd_Gettime( double* dTime );
ui32 ASL_Thrd_Create( struct ThrdInfo *psThrdInfo, void *pfFunction, void* pArg, ui32 dwPriority );
ui32 ASL_Thrd_Delete( struct ThrdInfo *psThrdInfo );

#endif /* Thread defined */
