/*************************************************************************
 *                          ACTIVE SILICON LIMITED                      
 *                                                                        
 *  File name   : xpl_dbg.c
 *  Project     : ASL maintained example code OS-dependent Gui interface
 *  Author      : Martin Bone
 *  Systems     : ANSI C, X Windows, MS-Windows
 *  Written     : 25-Feb-98
 *  Updated     : 
 *  Version     : 1:00:00                                                     
 *                                                                        
 *  Copyright   : ASL 
 **************************************************************************
 * Comments: 
 * Assumptions:
 * Comments : 
 * Revisions:
 */

/* Active Silicon Include files - pulls in X includes as required */
#include <asl_inc.h>
#include <xpl_inc.h>

FILE *pgLogFile;


/* Debug Handling routines
 * ***********************
 */
void DBG_Open( char *szLogFileBase )
{
   char LogFileName[256];

#if defined _MACINTOSH
   SIOUXSettings.asktosaveonclose = false;
   SIOUXSetTitle("\pPress Q to Quit");
#endif
   sprintf(LogFileName, "%s.log", szLogFileBase );
   if ( (pgLogFile = fopen(LogFileName, "w") ) == NULL )
      DBG_WriteString( 10, "\nCannot Create Log File..");

}


void DBG_Close( void )
{
   fclose( pgLogFile );
}


void DBG_WriteString( ui32 dwDebugLevel, char *szFormat, ...)
{
   va_list VaList;
   char cBuffer[256];

   if ( dwDebugLevel < gdwDebugLevel )
      return;

   va_start(VaList, szFormat);
   vsprintf(cBuffer, szFormat, VaList);
   va_end(VaList);

   fprintf(stdout, cBuffer);
   if ( pgLogFile != NULL )
      fprintf( pgLogFile, cBuffer);

   /* If the message is such that we are just about to terminate
    * then wait for a key press
    */
   if ((dwDebugLevel & XPL_DBG_PROMPT) != 0)
   {
#if defined _MACINTOSH
      fprintf(stdout, "\nSelect File::Quit to Continue..");
#else
      fprintf(stdout, "\nPress any Key to Continue..");
      ASL_getch();
#endif
   }

   return;
}

