/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : asl_inc.h                                               *
 *  Function    : Includes all include files                              *
 *  Project     : Snappers                                                *
 *  Author      : Colin Pearce, Active Silicon Ltd                        *
 *  Systems     : ANSI C                                                  *
 *  Written     : October 1993                                            *
 *  Updated     : 15-Jan-96                                               *
 *  Version     : 3.10                                                    *
 *                                                                        *
 *  Copyright (c) 1993-96 Active Silicon, Active Imaging Ltd.             *
 **************************************************************************
 *  Comments:
 */

#ifndef _asl_inc_h
#define _asl_inc_h

#if defined _SOLARIS2
#ifndef _REENTRANT
#define _REENTRANT
#include <pthread.h>
#include <thread.h>
#endif
#endif

#if defined _LINUX
#ifndef _REENTRANT
#define _REENTRANT
#endif
#include <pthread.h>
#endif

#ifndef _WIN31
#ifndef _WINNT
#ifndef _WIN95
#ifndef _MACOSX
#include <os_sys.h>   /* sets up operating system #defines */
#endif
#endif
#endif
#endif

/* The following and subsequent import statements fails under the Symnatec compiler even though _MACOSX isn't defined (a compiler bug).
 * Therefore to compile under Symantec, the import statements must either be commented out or deleted
 */
#if defined _MACOSX
#import <ASLsnapper/os_sys.h>
#endif

#if defined ( _VXWORKS ) || defined ( _VXWORKS_DRIVER )
#include <vxWorks.h>
/*
 * This file is included in all Snapper _VXWORKS modules.
 * The other system include files are only included in the
 * appropriate driver files
 */
#include <memLib.h>
#if defined _VXWORKS_DRIVER
#include <vmLib.h>
#include <cacheLib.h>
#include <intLib.h>
#include <vwModNum.h>
#endif
#endif

#if defined _WIN31 || defined _WINNT || defined _WIN95

#ifdef __WATCOMC__  /* Added for Watcom support under Windows 95 */
typedef int HANDLE;
#endif

#if defined _WINDOWS       /* This is an MS Windows definition */
#include <windows.h>  /* windows.h must be included first */
#include <windowsx.h>
#if defined _WIN31
#include <dciman.h>   /* Windows 3.1 DCI API */
#include <toolhelp.h> /* Windows 3.1 Timer Support */
#endif
#if defined _WIN95
#include <ddraw.h>    /* Windows 95 Direct Draw API */
#endif
#if defined _WINNT
#include <ddraw.h>    /* Windows NT (4) Direct Draw API */
#endif
#endif  /* end _WINDOWS */

#include <os_sys.h>   /* sets up operating system #defines */     

#ifndef __MWERKS__    /* LVR for CWPro2 compiler */
#include <conio.h>
#include <dos.h>
#endif
#include <io.h>

#elif defined _DOS
#ifdef _FG            /* allow _FG to be equivalent to _FG_GRAPHICS */
#ifndef _FG_GRAPHICS
#define _FG_GRAPHICS  /* put here due to Watcom command line length problems */
#endif
#endif
#include <conio.h>
#include <dos.h>
#include <io.h>
#if defined _DOS32 && defined __WATCOMC__
#include <stddef.h>   /* for cdecl calling convention */
/* NOTE: Force to always use ASM & DMA - needed as the Watcom command 
 * line compiler cannot cope with a very long command line length.
 */
#ifndef _ASL_DMA
#define _ASL_DMA
#define _ASL_ASM
#endif
#endif

#elif defined _SOLARIS
#include <sys/types.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <sys/sysconf.h>
#include <aio.h>

#if defined _XSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#endif

#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <thread.h>

/* X Imaging under Solaris
 * -----------------------
 */
#if defined _X_GRAPHICS
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#endif 

#if defined _XSHM
#include <X11/extensions/Xext.h>
#include <X11/extensions/XShm.h>
#endif

#elif defined _LINUX
#include <sys/types.h>
#include <sys/file.h>
#include <sys/mman.h>

#if defined _XSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#endif

#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sched.h>

/* X Imaging under Linux
 * -----------------------
 */
#if defined _X_GRAPHICS
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#endif

#if defined _XSHM
#include <X11/extensions/Xext.h>
#include <X11/extensions/XShm.h>
#endif

#elif defined _MACOSX
#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#import <mach/mach.h>
#import <mach/mach_error.h>
#import <CoreFoundation/CoreFoundation.h>
#import <IOKit/IOKitLib.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <OpenGL/OpenGL.h>

#elif defined _OS2
#define INCL_DOSERRORS
#define INCL_DOSDEVICES
#define INCL_DOSFILEMGR
#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include <mmioos2.h>  /* This is from MMPM toolkit */
#include <dive.h>
#include <fourcc.h>

#elif defined _MAC_LVR   /* LVR, 15-Jan-96 */
#include <Types.h>
#include <TextUtils.h>     /* c2pstr etc. */
#include <Devices.h>
#ifdef _OS_THREADS         /* LVR 04-Sep-96 */
 #include <Threads.h>
#endif
#include <QuickDraw.h>
#include <QDOffScreen.h>
#if defined __MWERKS__     /*MH 05-Sep-98 for sleep function in ASLEXAMP*/
#include <unistd.h>
#endif

#elif defined _MACINTOSH
#include <Types.h>
/* Following required to manipulate system strngs (pascal format) */
#include <TextUtils.h>
/* For System7/8 interfacing */
#include <Devices.h>
#include <Threads.h>
/* For standard file functions. These files are not part of the standard
 * development environment. They are part of the Apple Developer Connection.
 * i have included them in src\lib\mac.
 */
#include <Folders.h>
#include <FullPath.h>
/* QuickDraw is the generic low-level Macintosh pixel display library */
#include <QuickDraw.h>
#include <QDOffScreen.h>
/* end _MACINTOSH section */

#elif defined _LYNXOS
#include <unistd.h>
#include <pthread.h>       /* interrupt callback thread header files */
#include <sem.h>
#include <resource.h>

#if defined _X_GRAPHICS
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#endif 

#endif  /* Operating environment switches */


#include <stdarg.h>     /* must be before stdio.h for MS Windows */
#include <stdio.h>
#include <stdlib.h>
#ifndef _MACINTOSH    
#ifndef _MAC_LVR     /* LVR, 15-Jan-96 */
#ifndef _LYNXOS
#ifndef _VXWORKS
#ifndef _MACOSX
#include <malloc.h>
#endif
#endif
#endif
#endif
#endif
#include <math.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>

/*
 * Graphics Library for DOS: _FG_GRAPHICS - Flash Graphics, by Flashtek.
 */
#if defined _FG_GRAPHICS
#include <fg.h>
#endif

/*
 * 32 bit DOS Extender, X-32VM, by Flashtek.
 */
#if defined _DOS32       /* 32 bit DOS may use the X-32VM extender */
#include <x32.h>
#endif

#if defined _MACOSX
#import <ASLsnapper/asl_gen.h>     /* general purpose definitions */
#import <ASLsnapper/snp_rev.h>     /* Revision level information */
#import <ASLsnapper/shared.h>      /* definitions needed by libraries and drivers */
#import <ASLsnapper/tmg.h>
#import <ASLsnapper/base.h>
#import <ASLsnapper/isa_base.h>
#import <ASLsnapper/pci_base.h>
#import <ASLsnapper/sbusbase.h>
#import <ASLsnapper/module.h>
#import <ASLsnapper/crunch.h>
#import <ASLsnapper/cl550.h>
#import <ASLsnapper/dig16.h>
#import <ASLsnapper/snp16.h>
#import <ASLsnapper/snp24.h>
#import <ASLsnapper/fpga.h>     /* for compiled in FPGAs */

/* Prototypes & externs - these must be included after all other headers
 * so that all types used already exist
 */
#import <ASLsnapper/aslgenpr.h>
#import <ASLsnapper/tmg_pro.h>
#import <ASLsnapper/snp16pro.h>
#import <ASLsnapper/dig16pro.h>
#import <ASLsnapper/snp24pro.h>
#import <ASLsnapper/base_pro.h>
#import <ASLsnapper/fpga_pro.h>    /* for compiled in FPGAs */

#else
#include <asl_gen.h>     /* general purpose definitions */
#include <snp_rev.h>     /* Revision level information */
#include <shared.h>      /* definitions needed by libraries and drivers */
#ifndef _ASL_NO_TMG_INCLUDE  /* So that "new" TMG library may be used if required */
#include <tmg.h>
#endif
#include <base.h>
#include <isa_base.h>
#include <pci_base.h>
#include <sbusbase.h>
#include <module.h>
#include <crunch.h>
#include <cl550.h>
#include <dig16.h>
#include <snp16.h>
#include <snp24.h>
#include <fpga.h>     /* for compiled in FPGAs */

/* drivers */
#if defined _DOS || defined _WIN31
/* The DOS and Windows 3.1 "drivers" are compiled in with the Snapper library */
#include <dwin_drv.h>
#include <pci_bios.h>
#endif
#ifdef _SOLARIS
#include <sbus_drv.h>
#endif

/* Prototypes & externs - these must be included after all other headers
 * so that all types used already exist
 */
#include <aslgenpr.h>
#include <tmg_pro.h>
#include <snp16pro.h>
#include <dig16pro.h>
#include <snp24pro.h>
#include <base_pro.h>
#include <fpga_pro.h>    /* for compiled in FPGAs */
#endif /* ENDIF ELSE _MACOSX */
#if defined _DOS || defined _WIN31
#include <dwindrpr.h>
#endif

#endif   /* _asl_inc_h */
