/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : aslgenpr.h                                              *
 *  Function    : Protoypes for asl_gen.c                                 *
 *  Project     : General purpose                                         *
 *  Author      : Colin Pearce, Active Silicon Ltd                        *
 *  Systems     : ANSI                                                    *
 *  Written     : October 1993                                            *
 *  Updated     : 15-Jan-96                                               *
 *  Version     : 3.10                                                    *
 *                                                                        *
 *  Copyright (c) 1993-96 Active Silicon, Active Imaging Ltd.             *
 **************************************************************************
 *  Comments:
 */

#ifndef _ASLGENPR_H_
#define _ASLGENPR_H_

#ifndef EXPORT_FN_PTR
#define EXPORT_FN_PTR  __declspec(dllexport)*
#endif


/*
 * Prototype Definitions
 * =====================
 */
#ifdef __cplusplus
extern "C" {
#endif

void  EXPORT_FN     ASL_time(time_t*);
void  EXPORT_FN     ASL_check_mallocs(char*);
int   EXPORT_FN     ASL_check_mode_invalid(Tparam, Tparam);
int   EXPORT_FN     ASL_check_mode_one_selected(Tparam, Tparam);
void  EXPORT_FN     ASL_dos_delay(ui32);
void  EXPORT_FN     ASL_err_display(char*, Terr, char*);
void  EXPORT_FN     ASL_err_process(char*, Terr, char*);
#if defined _WINNT || defined _WIN95 || defined _MAC_LVR || defined _MACINTOSH || defined _MACOSX
Terr  EXPORT_FN     ASL_err_set_reporting(ui32, void (*)(char*, Terr, char*));
#else
Terr  EXPORT_FN     ASL_err_set_reporting(ui32, void (EXPORT_FN *)(char*, Terr, char*));
#endif
#if defined __WATCOMC__ && defined _DOS32
ui16 EXPORT_FN ASL_FP_SEG(void __far*);
#endif
void  EXPORT_FN     ASL_free(void*);
Terr  EXPORT_FN     ASL_get_fpga_data_and_length(char*, struct Tfpga_info*);
float EXPORT_FN     ASL_get_malloc_info(ui16);
ui32  EXPORT_FN     ASL_get_rbt_bit_length(char*);
Terr  EXPORT_FN     ASL_get_rbt_date_string(char*, char*);
Terr  EXPORT_FN     ASL_locate_fpga_rbt_file(char*, char*);
void  EXPORT_FN     ASL_loop_delay(ui32);
void  EXPORT_FN_PTR ASL_malloc(ui32);
ui32  EXPORT_FN     ASL_mul(ui32, ui32);
void  EXPORT_FN     ASL_pause(char*);
char  EXPORT_FN_PTR ASL_sscanf(char*, ui16*);
int   EXPORT_FN     ASL_strncmp(const char*, const char*, size_t);
void  EXPORT_FN     ASL_str_tolower(char*);
void  EXPORT_FN     ASL_str_toupper(char*);

ui16 EXPORT_FN get_ui16m(FILE*);
ui16 EXPORT_FN get_ui16i(FILE*);
ui32 EXPORT_FN get_ui32m(FILE*);
ui32 EXPORT_FN get_ui32i(FILE*);
ui16 EXPORT_FN parse_command( struct Tcmd*, int, char** );

#ifdef _WIN31
/*
 * addr_w31.c - Physical addres to huge pointer under Windows 3.1
 * ----------
 */
IM_UI8 EXPORT_FN_PTR phys_to_ptr(ui32, ui32, ui16);
ui32   EXPORT_FN MapPhysicalToLinear(ui32, ui32);
ui16   EXPORT_FN SynthSelector(ui32, ui32);
#endif

/*
 * asl_asm.c - Some special 32 bit assembler functions.
 * ---------
 */
#if defined _DOS16 || defined _WIN31
Terr EXPORT_FN ASL_block_copy_ui32(IM_UI32*, IM_UI32*, ui16);
Terr EXPORT_FN ASL_block_copy_ui32b(IM_UI32*, IM_UI32*, ui16); /* runs source pointer backwards */
Terr EXPORT_FN ASL_checker_copy_ui32(IM_UI32*, IM_UI32*, ui16, ui16, ui16, ui16);
Terr EXPORT_FN ASL_checker_copy_ui32b(IM_UI32*, IM_UI32*, ui16, ui16, ui16, ui16);
void DCICopyNLinesOld(IM_UI8*, struct Timage*, ui32, ui32, ui16, ui16, ui32);
#endif

#ifdef __cplusplus
};
#endif

#endif /* _ASLGENPR_H_ */
