/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        * 
 *  File name   : dwindrpr.h                                              * 
 *  Function    : Prototype definitions for ISA/PCI running DOS/Win31     * 
 *  Project     : Snapper                                                 * 
 *  Author      : Warren Frost, Active Silicon Ltd                        * 
 *  Systems     : ANSI C                                                  * 
 *  Written     : August 1994                                             * 
 *  Updated     : 15-Jan-96                                               *
 *  Version     : 3.10                                                    *
 *                                                                        * 
 *  Copyright (c) 1994-96 Active Silicon, Active Imaging Ltd.              *
 **************************************************************************
 *  Comments:
 */

#ifndef _dwindrpr_h
#define _dwindrpr_h

#ifdef __cplusplus             
extern "C" {      
#endif
/*
 * pc_drv.c (ISA/PCI running DOS/Windows 3.1)
 * -------- (dwin_drv.c would be a better name?)
 * This file compiles under 16 bit Microsoft C.
 */
#ifdef _WIN31
void DRV_Yield(void);
#endif
Terr EXPORT_FN ISA_DRV_fpga_configure(Thandle, struct Tfpga_info*);
Terr EXPORT_FN PC_DRV_fpga_configure(Thandle, struct Tfpga_info*);
Terr EXPORT_FN PC_DRV_fpga_get_config_status(Thandle, struct Tfpga_info*);
Terr EXPORT_FN PC_DRV_fpga_reset(Thandle, struct Tfpga_info*);
Terr EXPORT_FN PC_DRV_get_base_property(Thandle, char*, char*);
void EXPORT_FN PC_DRV_int_off(void);
void EXPORT_FN PC_DRV_int_on(void);
void EXPORT_FN PC_DRV_call_inswp(IM_UI16*,  ui32, ui32);    /* assembler call */
void EXPORT_FN PC_DRV_call_outswp(IM_UI16*, ui32, ui32);    /* assembler call */
void EXPORT_FN PC_DRV_call_inswr(IM_UI16*,  ui32, ui16);    /* assembler call */
void EXPORT_FN PC_DRV_call_outswr(IM_UI16*, ui32, ui16);    /* assembler call */
Terr EXPORT_FN PC_DRV_DMA_create_region_list_w31(Thandle);
Terr EXPORT_FN PC_DRV_DMA_destroy_region_list_w31(Thandle);
ui32 EXPORT_FN PC_DRV_DMA_lock_all_regions_w31(Thandle);
ui32 EXPORT_FN PC_DRV_DMA_lock_region_w31(struct TDDS*);
ui32 EXPORT_FN PC_DRV_DMA_unlock_all_regions_w31(Thandle);
ui32 EXPORT_FN PC_DRV_DMA_unlock_region_w31(struct TDDS*);
Terr EXPORT_FN PCI_DRV_DMA_to_display_w31(Thandle, ui32, ui16, ui16, ui16, ui16, ui16, ui16, ui16);
Terr EXPORT_FN PCI_DRV_shadow_EEPROM_ui8(Thandle);
ui32 EXPORT_FN PC_DRV_GetTimeStamp_ms(void);
Tboolean EXPORT_FN PC_DRV_Timeout(ui32);
Terr EXPORT_FN PCI_DRV_serial_transmit_buffer(Thandle, ui8*, ui32*, ui32);
Terr EXPORT_FN PCI_DRV_serial_receive_buffer(Thandle, ui8*, ui32*, ui32);
Terr EXPORT_FN PCI_DRV_wait_for_interrupt(Thandle, ui32, ui32);
Terr EXPORT_FN PCI_DRV_process_dylan_interrupt(Thandle);
Terr EXPORT_FN PCI_DRV_process_snapper_interrupt(Thandle);
Terr EXPORT_FN PCI_DRV_serial_flush_dylan(Thandle);
void EXPORT_FN PC_DRV_ExitCriticalSection(void);
void EXPORT_FN PC_DRV_EnterCriticalSection(void);


/*
 * pci_asm.c (ISA/PCI running DOS/Windows 3.1)
 * ---------
 * This file contains 32 bit assembler and requires a 32 bit compiler - 
 * Symantec is used (see mkpciw31.bat).
 */
Tboolean EXPORT_FN PCI_DRV_is_BIOS_present(ui8*, ui16*, ui8*);
Tboolean EXPORT_FN PCI_DRV_find_device(ui16, ui16, ui16, ui8*, ui8*);
Terr EXPORT_FN PCI_DRV_find_class_code(ui32, ui16, ui8*, ui8*);
Terr EXPORT_FN PCI_DRV_generate_special_cycle(ui8, ui32);
Terr EXPORT_FN PCI_DRV_read_cs_ui8(ui8, ui8, ui16);
Terr EXPORT_FN PCI_DRV_read_cs_ui16(ui8, ui8, ui16);
ui32 EXPORT_FN PCI_DRV_read_cs_ui32(ui8, ui8, ui16);
Terr EXPORT_FN PCI_DRV_write_cs_ui8(ui8, ui8, ui16, ui8);
Terr EXPORT_FN PCI_DRV_write_cs_ui16(ui8, ui8, ui16, ui16);
Terr EXPORT_FN PCI_DRV_write_cs_ui32(ui8, ui8, ui16, ui32);
Terr EXPORT_FN PCI_DRV_fpga_configure(Thandle, struct Tfpga_info*);
Terr EXPORT_FN PCI_DRV_fpga_configure_1bit(Thandle, struct Tfpga_info*);
Terr EXPORT_FN PCI_DRV_fpga_configure_32bit(Thandle, struct Tfpga_info*);
Tboolean EXPORT_FN PCI_DRV_is_DPMI_present_x32(void);
ui8  EXPORT_FN PCI_DRV_read_EEPROM_ui8(Thandle, ui32);
Terr EXPORT_FN PCI_DRV_write_EEPROM_ui8(Thandle, ui16, ui8);
ui32 EXPORT_FN PCI_DRV_read_dylan_ui32(Thandle, ui32);
Terr EXPORT_FN PCI_DRV_write_dylan_ui32(Thandle, ui32, ui32);
Terr EXPORT_FN PCI_DRV_write_dylan_burst_ui32(Thandle, ui32, ui8*);
Tboolean EXPORT_FN PCI_DRV_dylan_is_busy(Thandle);
Terr EXPORT_FN PCI_DRV_wait_for_dylan_not_busy(Thandle);
Tboolean EXPORT_FN PCI_DRV_is_FIFO_empty(Thandle);
ui32 EXPORT_FN PC_DRV_read_ui32(Thandle, ui32);
Terr EXPORT_FN PC_DRV_write_ui32(Thandle, ui32, ui32);
void EXPORT_FN PC_DRV_call_insdr(IM_UI32*,  ui32, ui16);  /* assembler call */
void EXPORT_FN PC_DRV_call_outsdr(IM_UI32*, ui32, ui16);  /* assembler call */
void EXPORT_FN PC_DRV_call_insdp(IM_UI32*,  ui32, ui32);  /* assembler call */
void EXPORT_FN PC_DRV_call_outsdp(IM_UI32*, ui32, ui32);  /* assembler call */
Terr EXPORT_FN PCI_DRV_DMA_in_r(Thandle, IM_UI32*, ui32, ui32);
Terr EXPORT_FN PCI_DRV_DMA_in_w31(Thandle, ui32, ui32, ui32);
Terr EXPORT_FN PCI_DRV_DMA_in_lock_w31(Thandle, IM_UI32*, ui32, ui32, ui32);
Terr EXPORT_FN PCI_DRV_DMA_in_x32(Thandle, IM_UI32*, ui32);
#ifdef __cplusplus
};
#endif

#endif  /* _dwindrpr_h */
