/*
 Copyright FlashTek, Inc. 1993
 121 Sweet Ave.
 Moscow, Idaho	83843

 March 24, 1993
 FAX:	208-882-7275
 email: fg@proto.com
*/

#ifndef _FG_H
#define _FG_H     1

/*---- START ASL (SNAPPER) CHANGES --------------*/
/*
 * NOTE Changes by ASL to work with MSVC++ and full ANSI
 * -----------------------------------------------------
 * 1. function "itoa" prototyped (see below).
 * 2. _far   -> __far   (see #define below).
 * 3. _cdecl -> __cdecl (see #define below).
 * 4. _near  -> __near  (see #define below).
 */
#ifndef _far         /* ASL */
#define _far __far
#endif

#ifndef _cdecl       /* ASL */
#define _cdecl __cdecl
#endif

#ifndef _near        /* ASL */
#define _near __near
#endif

/* Prototypes for non-ANSI functions */
/* --------------------------------- */
char *itoa(int, char*, int);  /* ASL */

/*---- END ASL (SNAPPER) CHANGES --------------*/

#if __WATCOMC__
 #ifdef M_I386
  #define __I86__ 3
 #else
  #define __I86__ 1
 #endif
#endif

#if (__I86__ > 2) || (__HIGHC__)
 #define _FG_FAR
#else /* (__I86__ > 2) ... */
 #define _FG_FAR _far
#endif

#ifdef __HIGHC__
 pragma Global_aliasing_convention("_%r");
 #define _cdecl
 #define _far _Dfar
 #define _near _Dnear

#pragma Push_align_members
#pragma Align_members(4)

 #ifdef CARDIAC
 extern char fg_font_8x8_1[][8];
 extern char fg_font_8x8_2[][8];
 extern char fg_font_8x14[][8];
 extern char fg_font_8x16[][8];
 #endif
#endif

#if __cplusplus
 extern "C" {
#endif

#if __BORLANDC__ || __TURBOC__
/* We require word boundary alignment.  Under Borland this requires a flag. */
 #pragma option -a
#endif

#if __ZTC__ || __SC__
 #if __I86__ >= 3
  #pragma ZTC align 4
 #else
  #pragma ZTC align 2
 #endif
#endif

#if __WATCOMC__ || _MSC_VER || __HIGHC__ /* If Watcom, Microsoft or MetaWare. */
 #define _FG_CDECL
#else
 #define _FG_CDECL _cdecl
#endif

/* Definition of basic coordinate system		*/

/************************************
 * Coordinate system (right-handed):
 *
 *	     Y2 +
 *		|
 *		|
 *		|
 *	     Y1 +-----------+
 *		X1	    X2
 *
 * Where:
 *	X1 <= X2
 *	Y1 <= Y2
 */

typedef int _FG_CDECL fg_coord_t;    /* data type for all coordinates		     */

/*****************************
 * Coordinate box.
 *	box[FG_X1] = x coordinate of left edge
 *	box[FG_Y1] = y coordinate of bottom edge
 *	box[FG_X2] = x coordinate of right edge
 *	box[FG_Y2] = y coordinate of top edge
 */

typedef fg_coord_t fg_box_t[4];
typedef fg_coord_t _FG_FAR *fg_pbox_t;		 /* pointer to a box	     */
typedef fg_coord_t const _FG_FAR *fg_const_pbox_t;/* pointer to a const box  */
typedef fg_coord_t fg_line_t[4];
typedef fg_coord_t _FG_FAR *fg_pline_t;		 /* pointer to a line	     */
typedef fg_coord_t const _FG_FAR *fg_const_pline_t;/* pointer to a const line*/
typedef unsigned short _FG_CDECL fg_pattern_t[16]; /* fill pattern data      */
typedef unsigned short _FG_CDECL _FG_FAR *fg_ppattern_t;/* Pointer to a pattern type*/

#define FG_X1 0
#define FG_Y1 1
#define FG_X2 2
#define FG_Y2 3

/* Change the definition of a FG_COLOR. */
/* As in 'fg_setcolornum(FG_WHITE, 7);' */
#define fg_setcolornum(old_color,new_num) ((old_color) = (new_num))

/*************************
 * Rotation values:
 */

#define FG_ROT0   0
#define FG_ROT90  1
#define FG_ROT180 2
#define FG_ROT270 3

/*************************
 * Mouse button defines.
 * Status of mouse has these bits set if that button is depressed.
 * 1 if down 0 if up.
 */

#define FG_MSM_LEFT   1
#define FG_MSM_RIGHT  2
#define FG_MSM_MIDDLE 4

#define FG_MSM_BUTTONS 3

/* Masks used for the fg_msm_signal function. */
#define FG_MSM_SIGNALMOVE	  1   /* Notify if motion occurred. */
#define FG_MSM_SIGNALBUTTONDOWNL  2   /* Notify if Left button went down. */
#define FG_MSM_SIGNALBUTTONUPL	  4   /* Notify if Left button went up. */
#define FG_MSM_SIGNALBUTTONDOWNR  8   /* Notify if right button went down. */
#define FG_MSM_SIGNALBUTTONUPR	 16   /* Notify if right button went up. */
#define FG_MSM_SIGNALBUTTONDOWNM 32   /* Notify if middle button went down. */
#define FG_MSM_SIGNALBUTTONUPM	 64   /* Notify if middle button went up. */

typedef struct fg_msm_button
{
  volatile unsigned int up_count;
  volatile fg_coord_t	up_last_x;
  volatile fg_coord_t	up_last_y;

  volatile unsigned int down_count;
  volatile fg_coord_t	down_last_x;
  volatile fg_coord_t	down_last_y;
} _FG_CDECL fg_msm_button_t;

typedef struct fg_msm_cursor
{
  char _FG_FAR *matrix;
  fg_box_t box;
  fg_coord_t hot_x, hot_y;
} _FG_CDECL fg_msm_cursor_t;


typedef struct fg_prop_font_info
{
  unsigned short int offset;	/* number of bytes to add to base to reach char data*/
  unsigned char width;	/* width of this char in pixels */  
} fg_prop_font_info_t;

typedef struct fg_font
{
  char _far * fontptr;	/* First 128 characters.  */
  char _far * fontptr2; /* Second 128 characters. */
  
  fg_box_t charbox;	/* Size of the character. */
  fg_coord_t baseline;	/* Distance from bottom of char to baseline. */
  char font_type;	/* 0=bitmapped fixed width fonts */
  			/* 1=bitmapped proportional fonts */
} _FG_CDECL fg_font_t;

typedef unsigned char _FG_CDECL fg_color_t;

struct fg_15color/* For future functionality with 15-bit color boards. */
{			/* VESA specifies 5 bits for each of the 3 colors. */
  int blue  : 5;
  int green : 5;
  int red   : 5;
  /* ASL (for Lint/32 bit) - Original code:
  unsigned short int blue  : 5;
  unsigned short int green : 5;
  unsigned short int red   : 5;*/
};

struct fg_16color/* For 16-bit color boards. */
{
  int blue  : 5;
  int green : 5;
  int red   : 5;
  /* ASL (for Lint/32 bit) - Original code:
  unsigned short int blue  : 5;
  unsigned short int green : 6;
  unsigned short int red   : 5;*/
};

struct fg_24color/* For 24-bit color boards. */
{			/* VESA specifies 8 bits for each of the 3 colors. */
  int blue  : 8;
  int green : 8;
  int red   : 8;
};

typedef union
{
  unsigned short int color;
  struct fg_15color rgb;
} _FG_CDECL fg_15color_t;

typedef union
{
  unsigned short int color;
  struct fg_16color rgb;
} _FG_CDECL fg_16color_t;

typedef union
{
  long int color;
  struct fg_24color rgb;
} _FG_CDECL fg_24color_t;

typedef struct
{
/*
This is designed to be the same as the Phar Lap structure for 286
DosRealIntr().
*/

  unsigned short es,ds;
  unsigned short di,si,bp,sp,bx,dx,cx,ax;
  unsigned ip, cs, flags;
} fg_regs16_t;

struct FG_HANDLE /* DON'T COUNT ON THIS STRUCTURE REMAINING THE SAME. */
{		 /* IT HAS CHANGED IN THE PAST AND MAY CHANGE IN THE FUTURE! */
  fg_box_t box;				 /* defines area that was saved */
  fg_color_t _FG_FAR * _FG_FAR *data;	 /* the data for the saved area */
};

typedef struct FG_HANDLE _FG_FAR *fg_handle_t;

typedef struct fg_graphic_mode
{
  char _FG_FAR *name;		    /* Mode name (like "FG_VGA12"). */
  int display;			    /* FG mode number (like FG_VGA12). */
  int (_cdecl _FG_FAR *init)(void); /* initialization function	    */
  fg_coord_t width, height;	    /* Pixel height and width of the screen. */
  long nsimulcolor;		    /* Number of simulataneous colors. */
  long ncolormap;		    /* Number of colors in the color map. */
} fg_graphic_mode_t;

/* The mode list is terminated with an entry that has 0 for the 'display'
member of the structure. */
extern fg_graphic_mode_t fg_modes[];

/* Defines for the type of display encountered	*/
#define FG_NULL     0	 /* all graphics are routed to bit bucket	 */

/* The following correspond to BIOS video modes:			     */
#ifndef __OS2__
#define FG_CGAMEDRES	4    /* IBM CGA in 320*200 color (mode 0x04)	     */
#endif

#define FG_CGAHIRES	6    /* IBM CGA in 640*200 (mode 0x06)		     */
#define FG_EGALOWRES	0x0D /* EGA in 320 x 200 x 16 colors (mode 0x0D)     */
#define FG_EGACOLOR	0x0E /* EGA with regular color display (mode 0x0E)   */
#define FG_EGAMONO	0x0F /* EGA with IBM monochrome monitor (mode 0x0F)  */
#define FG_EGAECD	0x10 /* EGA with enhanced color display (mode 0x10)  */
#define FG_VGA11	0x11 /* IBM VGA in 640*480, 1 color		     */
#define FG_VGA12	0x12 /* IBM VGA in 640*480, 16 colors		     */
#define FG_VGA13	0x13 /* IBM VGA in 320*200, 256 colors		     */
#define FG_VIRTUAL_1  0xFF01 /* Virtual buffer for 1 bit of color.	     */
#define FG_VIRTUAL_8  0xFF08 /* Virtual buffer for 8 bits of color.	     */

#define FG_TSENGHIRES	  0x29 /* Tseng Labs 800 x 600, 16 colors.	     */
#define FG_COMPAQPL	  0x40 /* Compaq gas plasma 640 x 400 x 2 colors.    */
#define FG_PARADISEHIRES  0x58 /* PARADISE VGA 800 x 600, 16 colors	     */
#define FG_TRIDENTHIRES   0x5B /* TRIDENT VGA 800 x 600, 16 colors	     */
#define FG_ATI61	 0xA61 /* ATI 640 x 400, 256 colors.		     */
#define FG_ATI62	 0xA62 /* ATI 640 x 480, 256 colors.		     */
#define FG_ATI63	 0xA63 /* ATI 800 x 600, 256 colors.		     */
#define FG_VEGAVGAHIRES   0x62 /* VIDEO 7 VEGA VGA in 800 x 600, 16 colors   */
#define FG_DFIHIRES	  0x64 /* Diamond Flower Instruments 800 x 600 x 16  */
#define FG_VESA6A	  0x6A /* VESA mode 0x6A, 800 x 600, 16 colors.      */
#define FG_EVGAHIRES	  0x70 /* Everex EVGA in 800 x 600, 16 colors	     */
#define FG_TOSHIBA	  0x74 /* Toshiba J-3100			     */

#define FG_VESA0	 0x100 /* VESA mode 0x100, 640 x 400, 256 colors.    */
#define FG_VESA1	 0x101 /* VESA mode 0x101, 640 x 480, 256 colors.    */
#define FG_VESA2	 0x102 /* VESA mode 0x102, 800 x 600, 16 colors.     */
#define FG_VESA3	 0x103 /* VESA mode 0x103, 800 x 600, 256 colors.    */
#define FG_VESA5	 0x105 /* VESA mode 0x105, 1024 x 768, 256 colors.   */
#define FG_VESA7	 0x107 /* VESA mode 0x107, 1280 x 1024, 256 colors.  */

#define FG_VESA4	 0x104 /* VESA mode 0x104, 1024 x 768, 16 colors.    */
#define FG_VESA6	 0x106 /* VESA mode 0x106, 1280 x 1024, 16 colors.   */

#define FG_VESAD	 0x10D /* VESA mode 0x10D, 320 x 200 x 32K colors.   */
#define FG_VESAE	 0x10E /* VESA mode 0x10E, 320 x 200 x 64K colors.   */
#define FG_VESAF	 0x10F /* VESA mode 0x10F, 320 x 200 x 16.8M colors.   */
#define FG_VESA10	 0x110 /* VESA mode 0x110, 640 x 480 x 32K colors.   */
#define FG_VESA11	 0x111 /* VESA mode 0x111, 640 x 480 x 64K colors.   */
#define FG_VESA12	 0x112 /* VESA mode 0x112, 640 x 480 x 16.8M colors.   */
#define FG_VESA13	 0x113 /* VESA mode 0x113, 800 x 600 x 32K colors.   */
#define FG_VESA14	 0x114 /* VESA mode 0x114, 800 x 600 x 64K colors.   */
#define FG_VESA15	 0x115 /* VESA mode 0x115, 800 x 600 x 16.8M colors.   */
#define FG_VESA16	 0x116 /* VESA mode 0x116, 1024 x 768 x 32K colors.   */
#define FG_VESA17	 0x117 /* VESA mode 0x117, 1024 x 768 x 64K colors.   */
#define FG_VESA18	 0x118 /* VESA mode 0x118, 1024 x 768 x 16.8M colors.   */
#define FG_VESA19	 0x119 /* VESA mode 0x119, 1280 x 1024 x 32K colors.   */
#define FG_VESA1A	 0x11A /* VESA mode 0x11A, 1280 x 1024 x 64K colors.   */
#define FG_VESA1B	 0x11B /* VESA mode 0x11B, 1280 x 1024 x 16.8M colors.   */


#define FG_HERCHALF	     2 /* Hercules monochrome, 1 display page  */
#define FG_HERCFULL	     3 /* Hercules monochrome, 2 display pages */
#define FG_8514A_8_640	0x8501 /* 8514A with 640 x 480 x 256 colors    */
#define FG_8514A_8_1024 0x8502 /* 8514A with 1024 x 768 x 256 colors   */
#define FG_TIGA_8_640	0x3401 /* TIGA 2.0 with 640 x 480 x 256 colors.      */
#define FG_TIGA_8_1024	0x3402 /* TIGA 2.0 with 1024 x 768 x 256 colors.     */
#define FG_TIGA_8_1280	0x3403 /* TIGA 2.0 with 1280 x 1024 x 256 colors.    */
#define FG_PYRAMID	0x7779
#define FG_PYRAMID2	0x777A

/* Used for filling outlines of pixels, see fg_outlinefill().		*/
#define FG_FILL_ON_RIGHT 1  /* Don't change these without careful	*/
#define FG_FILL_ON_LEFT  0  /* consideration of the source code. See	*/
			    /* the static function delete_excess.	*/

/* Collect global variables into a single structure. */
typedef struct fg_state
{
char _FG_FAR *version;
int  (_cdecl _FG_FAR *init_p)(void);
void (_cdecl _FG_FAR *term_p)(void);
void (_cdecl _FG_FAR *msm_flush_p)(void);
void (_cdecl _FG_FAR *msm_hidecursor_p)(void);
void (_cdecl _FG_FAR *msm_init_p)(void);
void (_cdecl _FG_FAR *msm_output_p)(fg_coord_t x, fg_coord_t y);
void (_cdecl _FG_FAR *msm_showcursor_p)(void);
void (_cdecl _FG_FAR *msm_term_p)(void);

#define FG_LINE_MAX	12
  unsigned short int linetype[FG_LINE_MAX];

#define FG_COLOR_MAX	21
  unsigned long int color[FG_COLOR_MAX];

  short int saddr;
  char _far *fontptr, _far *fontptr2;
  int activepage;
  int displaypage;
  fg_box_t charbox;
  int display;	    /* FGxxxxx	    */
  fg_box_t displaybox;
  long ncolormap;
  long nsimulcolor;
  int numpages;
  int pixelx, pixely;
/* Function pointers (initialized by fg_init_xxxx())	*/
void (_cdecl _FG_FAR *blit_p)(fg_const_pbox_t, fg_coord_t, fg_coord_t,int,int);
void (_cdecl _FG_FAR *drawarc_p)(int,int,int,fg_coord_t,fg_coord_t,
		  fg_coord_t,int,int,fg_const_pbox_t);
void (_cdecl _FG_FAR *drawdot_p)(int,int,int,fg_coord_t,fg_coord_t);
void (_cdecl _FG_FAR *drawline_p)(int,int,int,int,fg_const_pline_t);
void (_cdecl _FG_FAR *drawlinep_p)(int,int,int,int,fg_const_pline_t);
void (_cdecl _FG_FAR *drawmatrix_p)(int,int,int,int,fg_coord_t,
		  fg_coord_t,char _FG_FAR *, fg_const_pbox_t,fg_const_pbox_t);
void (_cdecl _FG_FAR *fillbox_p)(int, int, int, fg_const_pbox_t);
void (_cdecl _FG_FAR *flush_p)(void);
void (_cdecl _FG_FAR *putc_p)(int,int,int,int,fg_coord_t,
		  fg_coord_t,char,fg_const_pbox_t);
void (_cdecl _FG_FAR *readbox_p) (fg_const_pbox_t, fg_color_t _FG_FAR *);
int  (_cdecl _FG_FAR *readdot_p)(fg_coord_t,fg_coord_t);
void (_cdecl _FG_FAR *setdisplaypage_p)(unsigned int);
void (_cdecl _FG_FAR *setactivepage_p)(unsigned int);
void (_cdecl _FG_FAR *setlinepattern_p)(int, int);
void (_cdecl _FG_FAR *writebox_p)(fg_const_pbox_t, const fg_color_t _FG_FAR *);
void (_cdecl _FG_FAR *setpalette_p)(int color_num,fg_color_t red,
				    fg_color_t green,fg_color_t blue);

  char text_rows, attribute, text_mode;
  unsigned char msm;	       /* Mouse present flag.		      */
  unsigned char msm_motion;    /* Mouse motion translation algorithm. */
  unsigned char palette[17];   /* Only valid for some modes.	      */
  unsigned char captured;     /* UNIX only.  Non-zero if screen is active. */
  unsigned char adapter_class;/* UNIX only.  EGA/VGA flag. */
#define FG_FILL_SOLID	      0
#define FG_FILL_BSLASH	      1
#define FG_FILL_SLASH	      2
#define FG_FILL_HATCH	      3
#define FG_FILL_LINE	      4
#define FG_FILL_THICK_X       5
#define FG_FILL_THIN_X	      6
#define FG_FILL_SCALE	      7
#define FG_FILL_WIDEDOT       8
#define FG_FILL_CLOSEDOT      9
#define FG_FILL_DIAMOND       10
#define FG_FILL_USER_DEFINED  11
#define FG_FILL_PATTERN_MAX   12
  fg_pattern_t filltype[FG_FILL_PATTERN_MAX];
  fg_handle_t saved_screen;   /* UNIX only.  Image is stored here while */
			      /* screen is not active. */
  fg_coord_t font_baseline;
fg_handle_t (_cdecl _FG_FAR *save_p)(fg_const_pbox_t);
void (_cdecl _FG_FAR *put_handle_p)(fg_handle_t);
void (_cdecl _FG_FAR *getpalette_p)(int color_num,fg_color_t _FG_FAR *r,
		     fg_color_t _FG_FAR *g, fg_color_t _FG_FAR *b);
void (_cdecl _FG_FAR *drawellipse_p)(int,int,int,fg_coord_t,fg_coord_t,
		    fg_coord_t, fg_coord_t,int,int,fg_const_pbox_t);
void (_cdecl _FG_FAR *fill_p)(fg_coord_t,fg_coord_t,int,int);
void (_cdecl _FG_FAR *fillpattern_p)(fg_coord_t,fg_coord_t,int,int,int);
void (_cdecl _FG_FAR *free_handle_p)(fg_handle_t);
unsigned int mallocs_outstanding;
unsigned short int window_io_address;	  /* FG private. */
unsigned short int window_num;		  /* FG private. */
void (_cdecl _FG_FAR *window_set_p)(void);/* FG private. */
unsigned int window_size;		  /* FG private. */
unsigned int window_end;		  /* FG private. */
void *x_table, *y_table;		  /* FG private. */
void (_cdecl _FG_FAR *writebox_tb_p)(fg_const_pbox_t,
				 const fg_color_t _FG_FAR *);
void (_cdecl _FG_FAR *writeboxi_p)(fg_const_pbox_t,
				 const fg_color_t _FG_FAR *,int);
void (_cdecl _FG_FAR *writeboxi_tb_p)(fg_const_pbox_t,
				 const fg_color_t _FG_FAR *,int);
void (_cdecl _FG_FAR *real_mode_int_p)(void);/* FG private. */
void (_cdecl _FG_FAR *msm_signal_p)(unsigned int,unsigned int,
				    fg_coord_t, fg_coord_t);
fg_msm_button_t msm_buttons[FG_MSM_BUTTONS];
fg_box_t     msm_clipbox;
volatile fg_coord_t   msm_x;
volatile fg_coord_t   msm_y;
volatile unsigned short msm_status;
unsigned short msm_mask;

signed char  msm_show;
volatile unsigned char msm_lock;
unsigned char msm_flushed;
unsigned char isr_inactive;

/* Non-zero if inside a potentially non-rentrant portion of FG. */
volatile char inside;
unsigned char msm_xratio, msm_yratio;
unsigned char bytes_per_pixel;

char font_type;
} _FG_CDECL fg_state_t;

extern fg_state_t fg;

extern int  _cdecl _FG_FAR fg_init(void);
extern void _cdecl _FG_FAR fg_term(void);
extern void _cdecl _FG_FAR fg_msm_flush(void);
extern void _cdecl _FG_FAR fg_msm_hidecursor(void);
extern void _cdecl _FG_FAR fg_msm_init(void);
extern void _cdecl _FG_FAR fg_msm_output(fg_coord_t x, fg_coord_t y);
extern void _cdecl _FG_FAR fg_msm_showcursor(void);
extern void _cdecl _FG_FAR fg_msm_term(void);
extern void _cdecl _FG_FAR fg_msm_signal(unsigned,
		     void (_cdecl *)(unsigned,unsigned,fg_coord_t,fg_coord_t));

extern void _cdecl _FG_FAR fg_blit(fg_const_pbox_t, fg_coord_t, fg_coord_t,int,int);
extern void _cdecl _FG_FAR fg_drawarc(int,int,int,fg_coord_t,fg_coord_t,
		     fg_coord_t,int,int,fg_const_pbox_t);
extern void _cdecl _FG_FAR fg_drawdot(int,int,int,fg_coord_t,fg_coord_t);
extern void _cdecl _FG_FAR fg_drawline(int,int,int,int,fg_const_pline_t);
extern void _cdecl _FG_FAR fg_drawlinep(int,int,int,int,fg_const_pline_t);
extern void _cdecl _FG_FAR fg_drawmatrix(int,int,int,int,fg_coord_t,
		   fg_coord_t,char _FG_FAR *, fg_const_pbox_t,fg_const_pbox_t);

extern void _cdecl _FG_FAR fg_fillbox(int, int, int, fg_const_pbox_t);
extern void _cdecl _FG_FAR fg_filldisplay(int color,int mode,int mask);
extern void _cdecl _FG_FAR fg_flush(void);
extern void _cdecl _FG_FAR fg_putc(int,int,int,int,fg_coord_t,
		      fg_coord_t,char,fg_const_pbox_t);
extern void _cdecl _FG_FAR fg_putc_bg(int,int,int,int,fg_coord_t,
		      fg_coord_t,char,fg_const_pbox_t,int bg_color);
extern void _cdecl _FG_FAR fg_readbox(fg_const_pbox_t, fg_color_t _FG_FAR *);
extern int  _cdecl _FG_FAR fg_readdot(fg_coord_t,fg_coord_t);
extern void _cdecl _FG_FAR fg_setdisplaypage(unsigned int);
extern void _cdecl _FG_FAR fg_setactivepage(unsigned int);
extern void _cdecl _FG_FAR fg_setlinepattern(int, int);
extern void _cdecl _FG_FAR fg_writebox(fg_const_pbox_t,
				       const fg_color_t _FG_FAR *);
extern void _cdecl _FG_FAR fg_writeboxi(fg_const_pbox_t,
				       const fg_color_t _FG_FAR *, int ignore);
extern void _cdecl _FG_FAR fg_writebox_tb(fg_const_pbox_t,
				       const fg_color_t _FG_FAR *);
extern void _cdecl _FG_FAR fg_writeboxi_tb(fg_const_pbox_t,
				       const fg_color_t _FG_FAR *, int ignore);
extern void _cdecl _FG_FAR fg_writebox_extract(fg_const_pbox_t dest,
           const void _FG_FAR *buf,fg_const_pbox_t source,
           fg_coord_t x_offset, fg_coord_t y_offset);
extern void _cdecl _FG_FAR fg_setpalette(int color_num, fg_color_t red,
					 fg_color_t green, fg_color_t blue);
extern fg_handle_t _cdecl _FG_FAR fg_save(fg_const_pbox_t);
extern void _cdecl _FG_FAR fg_put_handle(fg_handle_t);
extern void _cdecl _FG_FAR fg_getpalette(int color_num,
			     fg_color_t _FG_FAR *r,fg_color_t _FG_FAR *g,fg_color_t _FG_FAR *b);
extern void _cdecl _FG_FAR fg_init_256_palette(void);
extern void _cdecl _FG_FAR fg_init_bios16_palette(void);
extern void _cdecl _FG_FAR fg_drawellipse(int,int,int,fg_coord_t,
			   fg_coord_t,fg_coord_t,fg_coord_t,int,int,
			   fg_const_pbox_t);
extern void _cdecl _FG_FAR fg_fill(fg_coord_t,fg_coord_t,int,int);
extern void _cdecl _FG_FAR fg_fillpattern(fg_coord_t,fg_coord_t,int,int,int);
extern void _cdecl _FG_FAR fg_free_handle(fg_handle_t);

extern void _cdecl _FG_FAR fg_assert(const char _FG_FAR *,const char _FG_FAR *,
			      unsigned);
extern int _cdecl _FG_FAR fg_get_type(void);
extern int _cdecl _FG_FAR fg_init_cga(void);
extern int _cdecl _FG_FAR fg_init_egaecd(void);
extern int _cdecl _FG_FAR fg_init_egamono(void);
extern int _cdecl _FG_FAR fg_init_egacolor(void);
extern int _cdecl _FG_FAR fg_init_null(void);
extern int _cdecl _FG_FAR fg_init_vga11(void);
extern int _cdecl _FG_FAR fg_init_vga12(void);
extern int _cdecl _FG_FAR fg_init_virtual_1(unsigned char _FG_FAR *buffer,
				     fg_const_pbox_t box);
extern int _cdecl _FG_FAR fg_init_virtual_8(unsigned char _FG_FAR *buffer,
				     fg_const_pbox_t box);
extern int _cdecl _FG_FAR fg_init_ati61();
extern int _cdecl _FG_FAR fg_init_ati62();
extern int _cdecl _FG_FAR fg_init_ati63();
extern int _cdecl _FG_FAR fg_init_compaqpl();
extern int _cdecl _FG_FAR fg_init_paradisehires(void);
extern int _cdecl _FG_FAR fg_init_tridenthires(void);
extern int _cdecl _FG_FAR fg_init_tsenghires(void);
extern int _cdecl _FG_FAR fg_init_dfihires(void);
extern int _cdecl _FG_FAR fg_init_evgahires(void);
extern int _cdecl _FG_FAR fg_init_vegavgahires(void);
extern int _cdecl _FG_FAR fg_init_tiga_8_640(void);
extern int _cdecl _FG_FAR fg_init_tiga_8_1024(void);
extern int _cdecl _FG_FAR fg_init_tiga_8_1280(void);
extern int _cdecl _FG_FAR fg_init_toshiba(void);
extern int _cdecl _FG_FAR fg_init_8514a_8_640(void);
extern int _cdecl _FG_FAR fg_init_8514a_8_1024(void);
extern int _cdecl _FG_FAR fg_init_pyramid(void);
extern int _cdecl _FG_FAR fg_init_pyramid2(void);
extern int _cdecl _FG_FAR fg_init_vesa0(void);
extern int _cdecl _FG_FAR fg_init_vesa1(void);
extern int _cdecl _FG_FAR fg_init_vesa2(void);
extern int _cdecl _FG_FAR fg_init_vesa3(void);
extern int _cdecl _FG_FAR fg_init_vesa4(void);
extern int _cdecl _FG_FAR fg_init_vesa5(void);
extern int _cdecl _FG_FAR fg_init_vesa6(void);
extern int _cdecl _FG_FAR fg_init_vesa7(void);
extern int _cdecl _FG_FAR fg_init_vesaD(void);
extern int _cdecl _FG_FAR fg_init_vesaE(void);
extern int _cdecl _FG_FAR fg_init_vesaF(void);
extern int _cdecl _FG_FAR fg_init_vesa10(void);
extern int _cdecl _FG_FAR fg_init_vesa11(void);
extern int _cdecl _FG_FAR fg_init_vesa12(void);
extern int _cdecl _FG_FAR fg_init_vesa13(void);
extern int _cdecl _FG_FAR fg_init_vesa14(void);
extern int _cdecl _FG_FAR fg_init_vesa15(void);
extern int _cdecl _FG_FAR fg_init_vesa16(void);
extern int _cdecl _FG_FAR fg_init_vesa17(void);
extern int _cdecl _FG_FAR fg_init_vesa18(void);
extern int _cdecl _FG_FAR fg_init_vesa19(void);
extern int _cdecl _FG_FAR fg_init_vesa1A(void);
extern int _cdecl _FG_FAR fg_init_vesa1B(void);
extern int _cdecl _FG_FAR fg_init_vesa6A(void);
extern int _cdecl _FG_FAR fg_init_egalowres(void);
extern int _cdecl _FG_FAR fg_init_cgamedres(void);
extern int _cdecl _FG_FAR fg_init_vga13(void);
extern int _cdecl _FG_FAR fg_init_herc(void);
extern int _cdecl _FG_FAR fg_init_herchalf(void);
extern int _cdecl _FG_FAR fg_init_hercfull(void);

extern unsigned _cdecl _FG_FAR fg_msm_getpress(unsigned _FG_FAR *,
			fg_coord_t _FG_FAR *,fg_coord_t _FG_FAR *);
extern unsigned _cdecl _FG_FAR fg_msm_getrelease(unsigned _FG_FAR *,
			fg_coord_t _FG_FAR *, fg_coord_t _FG_FAR *);
extern unsigned _cdecl _FG_FAR fg_msm_getstatus(fg_coord_t _FG_FAR *,
			fg_coord_t _FG_FAR *);
extern void _cdecl _FG_FAR fg_msm_setarea(fg_const_pbox_t);
extern void _cdecl _FG_FAR fg_msm_setcurpos(fg_coord_t,fg_coord_t);
extern void _cdecl _FG_FAR fg_msm_setcursor(fg_msm_cursor_t cursor);
extern void _cdecl _FG_FAR fg_msm_setratio(unsigned,unsigned);

extern fg_coord_t _cdecl _FG_FAR fg_coord_midpoint(fg_coord_t a, fg_coord_t b);
extern fg_coord_t _cdecl _FG_FAR fg_box_height(fg_const_pbox_t b);
extern fg_coord_t _cdecl _FG_FAR fg_box_width(fg_const_pbox_t b);
extern unsigned int _cdecl _FG_FAR fg_matrix_size(fg_const_pbox_t b);
extern unsigned long int _cdecl _FG_FAR fg_box_area(fg_const_pbox_t b);
extern fg_pline_t _cdecl _FG_FAR fg_make_line(fg_pline_t l,
				       fg_coord_t x1,
				       fg_coord_t y1,
				       fg_coord_t x2,
				       fg_coord_t y2);
extern fg_pbox_t _cdecl _FG_FAR fg_make_box(fg_pbox_t b,
				     fg_coord_t x1,
				     fg_coord_t y1,
				     fg_coord_t x2,
				     fg_coord_t y2);
extern int _cdecl _FG_FAR fg_line_horiz(fg_const_pline_t line);
extern int _cdecl _FG_FAR fg_line_vert(fg_const_pline_t line);
extern int _cdecl _FG_FAR fg_line_zerolength(fg_const_pline_t line);
extern fg_pbox_t _cdecl _FG_FAR fg_box_cpy(fg_pbox_t to,fg_const_pbox_t from);

extern void _cdecl _FG_FAR fg_msm_motion(unsigned char a);
extern void _cdecl _FG_FAR fg_msm_setoutput(
		   void (_cdecl _FG_FAR *func_p)(fg_coord_t x, fg_coord_t y));

extern int _cdecl _FG_FAR fg_box_enclose(fg_const_pbox_t b1, fg_const_pbox_t b2);
extern int _cdecl _FG_FAR fg_pt_inbox(fg_const_pbox_t clip,fg_coord_t x,
				      fg_coord_t y);
extern int _cdecl _FG_FAR fg_getfillside(const fg_coord_t _FG_FAR *p,
					 unsigned int vertices);
extern unsigned _cdecl _FG_FAR fg_linepixels (fg_const_pline_t line);
extern fg_pline_t _cdecl _FG_FAR fg_line_cpy(fg_pline_t to,
					     fg_const_pline_t from);
extern int _cdecl _FG_FAR fg_lineclip(fg_const_pbox_t clip,
				      fg_const_pline_t fline,fg_pline_t lin);
extern void _cdecl _FG_FAR fg_setenv_variable (const char _FG_FAR *new_string);
extern void _cdecl _FG_FAR
  fg_fillboxdissolve(int color,int mode, int mask,fg_const_pbox_t box,
		     unsigned int count, int (_cdecl _FG_FAR *func_p)(void));
extern void _cdecl _FG_FAR fg_writeboxdissolve(fg_const_pbox_t box,
		    const fg_color_t _FG_FAR *p, unsigned int count,
		    int (_cdecl _FG_FAR *func_p)(void));
extern void _cdecl _FG_FAR fg_writeboxdissolve_tb(fg_const_pbox_t box,
		    const fg_color_t _FG_FAR *p, unsigned int count,
		    int (_cdecl _FG_FAR *func_p)(void));
extern void _cdecl _FG_FAR
  fg_fillboxpattern(int color, int mode, int mask,fg_const_pbox_t b,
		    int pattern);
extern void _cdecl _FG_FAR
  fg_drawdotpattern(int color,int mode,int mask,fg_coord_t x,
		    fg_coord_t y, int pattern);
extern int _cdecl _FG_FAR
  fg_fillpolygonpattern(int color,int mode,int mask,
			unsigned int vertices,const fg_coord_t _FG_FAR *polygon,
			fg_const_pbox_t clipbox,int pattern);
extern int _cdecl _FG_FAR
  fg_fillpolygon(int color,int mode,int mask,unsigned int vertices,
		 const fg_coord_t _FG_FAR *polygon,fg_const_pbox_t clipbox);
extern void _cdecl _FG_FAR fg_restore (fg_handle_t);
extern void _cdecl _FG_FAR fg_free_handle (fg_handle_t);
extern void _cdecl _FG_FAR fg_setfillpattern(int, fg_ppattern_t);
extern void _cdecl _FG_FAR
  fg_drawlinepattern(int,int,int,int,fg_const_pline_t);
extern void _cdecl _FG_FAR
  fg_drawlineclip(int color,int mode,int mask,int fg_line_type,
		  fg_const_pline_t line, fg_const_pbox_t clip);
extern void _cdecl _FG_FAR
  fg_drawlinepatternclip(int color,int mode,int mask,int pattern,
			 fg_const_pline_t line, fg_const_pbox_t clip);
extern void _cdecl _FG_FAR
  fg_drawlinepclip(int color,int mode,int mask,int fg_line_type,
		   fg_const_pline_t line,fg_const_pbox_t clip);
extern void _cdecl _FG_FAR
  fg_drawbox (int,int,int,int,fg_const_pbox_t,fg_const_pbox_t);
extern void _cdecl _FG_FAR
  fg_drawpolygon(int color,int mode,int mask,int line_type,
		 unsigned int vertices, const fg_coord_t _FG_FAR *polygon,
		 fg_const_pbox_t clipbox);
extern void _cdecl _FG_FAR
  fg_filloutline(int color,int mode,int mask,
		 const fg_coord_t _FG_FAR *out_line,
		 fg_coord_t _FG_FAR *buf,unsigned int pixels,int fill_side,
		 fg_const_pbox_t clipbox);
extern void _cdecl _FG_FAR
  fg_fillellipsepattern(int color,int mode,int mask,fg_coord_t x_center,
			fg_coord_t y_center,fg_coord_t x_radius,
			fg_coord_t y_radius, fg_const_pbox_t clipbox,
			int pattern);
extern void _cdecl _FG_FAR
  fg_filloutlinepattern(int color,int mode,int mask,
			const fg_coord_t _FG_FAR *out_line,
			fg_coord_t _FG_FAR *buf,unsigned int pixels,
			int fill_side,fg_const_pbox_t clipbox,int pattern);
extern fg_pbox_t _cdecl _FG_FAR fg_text_size(unsigned char *,fg_pbox_t);
extern void _cdecl _FG_FAR
  fg_puts(int,int,int,int,fg_coord_t,fg_coord_t,const char _FG_FAR *,
	  fg_const_pbox_t);
extern void _cdecl _FG_FAR
  fg_puts_bg(int,int,int,int,fg_coord_t,fg_coord_t,const char _FG_FAR *,
	  fg_const_pbox_t, int bg_color);
extern void _cdecl _FG_FAR fg_adjustxy(int,int,fg_coord_t _FG_FAR *,
		  fg_coord_t _FG_FAR *,fg_const_pbox_t);
extern unsigned _cdecl _FG_FAR fg_traverseline (int line_type,
		 fg_const_pline_t ln_ptr, fg_coord_t _FG_FAR *pt_pairs);
extern unsigned _FG_FAR _cdecl fg_traverseellipse(fg_coord_t x_center,
    fg_coord_t y_center,fg_coord_t x_radius,fg_coord_t y_radius,int start_ang,
    int end_ang, fg_coord_t _FG_FAR *pt_pairs);
extern void _cdecl _FG_FAR fg_outbuf(int color, int mode, int mask,
	       const fg_coord_t _FG_FAR *pt_pairs, unsigned int pairs);
extern void _cdecl _FG_FAR fg_outbufclip(int color,int mode,int mask,
	       const fg_coord_t _FG_FAR *pt_pairs, unsigned int pairs,
	       fg_const_pbox_t clip);
extern void _cdecl _FG_FAR
  fg_drawthickline(int,int,int,int,fg_const_pline_t,fg_const_pbox_t,int);
extern void _cdecl _FG_FAR fg_set_font(const fg_font_t _FG_FAR *newfont_p);
extern void _cdecl _FG_FAR fg_get_font(fg_font_t _FG_FAR *dest_p);
extern int _cdecl _FG_FAR fg_set_6x7_font(void);
extern int _cdecl _FG_FAR fg_set_8x8_font(void);
extern int _cdecl _FG_FAR fg_set_8x14_font(void);
extern int _cdecl _FG_FAR fg_set_8x16_font(void);
extern int _cdecl _FG_FAR fg_set_9x14_font(void);
extern int _cdecl _FG_FAR fg_set_15x19_font(void);
extern int _cdecl _FG_FAR fg_set_60p_font(void);
extern int _cdecl _FG_FAR
  fg_boxclip(fg_const_pbox_t clip, fg_const_pbox_t box_in,fg_pbox_t box_out);
extern void _FG_FAR * _FG_FAR _cdecl fg_malloc(unsigned bytes);
extern void _FG_FAR _cdecl fg_free(void _FG_FAR *p);

extern fg_state_t _FG_FAR * _cdecl _FG_FAR fg_get_state(void);
extern void _cdecl _FG_FAR
  fg_set_state(fg_state_t _FG_CDECL _FG_FAR *new_state,
	       fg_state_t _FG_CDECL _FG_FAR *old_state);
extern void _cdecl _FG_FAR fg_free_state(fg_state_t _FG_CDECL _FG_FAR *p);
extern fg_graphic_mode_t _FG_FAR * _cdecl _FG_FAR fg_find_mode(int display,
  char _FG_FAR *name);
extern int _cdecl _FG_FAR fg_init_mode(int mode);
extern int _cdecl _FG_FAR fg_get_first(void);
extern int _cdecl _FG_FAR fg_get_next(void);
extern void _cdecl _FG_FAR fg_real_mode_int(void);
extern fg_pbox_t _cdecl fg_box_normalize(fg_pbox_t box);
extern unsigned int _cdecl _FG_FAR fg_wait_for_vrt(void);


/* Writing modes	*/
#define FG_MODE_XOR   3
#define FG_MODE_OR    2
#define FG_MODE_AND   1
#define FG_MODE_SET   0

/* Line types	*/
#define    FG_LINE_SOLID	 0
#define    FG_LINE_LONG_DASH	 1
#define    FG_LINE_MEDIUM_DOTTED 2
#define    FG_LINE_DASH_DOTTED	 3
#define    FG_LINE_MEDIUM_DASHED 4
#define    FG_LINE_DASH_W_2_DOTS 5
#define    FG_LINE_SHORT_DASH	 6
#define    FG_LINE_DENSE_DOTTED  7
#define    FG_LINE_SPARSE_DOTTED 8
#define    FG_LINE_USER_DEFINED  9
#define    FG_LINE_FG_RESERVED1  10
#define    FG_LINE_FG_RESERVED2  11

/* Values for color	*/
#define FG_BLACK	fg.color[0]
#define FG_BLUE         fg.color[1]
#define FG_GREEN        fg.color[2]
#define FG_CYAN         fg.color[3]
/* Cyan is the same as BLUE_GREEN. */
#define FG_BLUE_GREEN   fg.color[3]
#define FG_RED          fg.color[4]
#define FG_MAGENTA      fg.color[5]
/* Purple is the same as magenta. */
#define FG_PURPLE       fg.color[5]
#define FG_YELLOW       fg.color[6]
#define FG_WHITE	fg.color[7]
#define FG_GRAY         fg.color[8]
#define FG_LIGHT_BLUE	fg.color[9]
#define FG_LIGHT_GREEN  fg.color[10]
#define FG_LIGHT_CYAN   fg.color[11]
/* Light blue-green is the same as light_cyan. */
#define FG_LIGHT_BLUE_GREEN     fg.color[11]
#define FG_LIGHT_RED    fg.color[12]
#define FG_LIGHT_MAGENTA fg.color[13]
#define FG_BROWN        fg.color[14]
/* normally an intense white  */
#define FG_LIGHT_WHITE	fg.color[15]
/* Same as LIGHT_WHITE */
#define FG_HIGHLIGHT	fg.color[15]
/* blinking white   */
#define FG_BLINK        fg.color[16]

#ifndef __HIGHC__
/* Used to guarantee the header file matches the libraries. */
#ifndef FG_SYNCHRONIZED
static void _near fg_version_sync(void)
{
  extern char _FG_CDECL fg_version_sync_Jul_29_1993;
  fg_version_sync_Jul_29_1993 = 0;
}
#endif
#endif

#if __BORLANDC__ || __TURBOC__
/* Restore alignment to the default under Borland. */
#pragma option -a.
#endif

#if __ZTC__ || __SC__
/* Restore alignment to the default. */
#pragma ZTC align
#endif

#ifdef __HIGHC__
#pragma Global_aliasing_convention();
#pragma Pop_align_members
#endif

#if __WATCOMC__
#pragma aux fg "_*";
extern char fg_osmode;
#pragma aux fg_osmode "_*";
#pragma aux fg_version_sync_Jul_29_1993 "_*";
#endif

#if __cplusplus
}
#endif

#endif	/* ifndef _FG_H */
