/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : fpga.h                                                  *
 *  Function    : Definitions for compiled in FPGA structure              *
 *  Project     : Snappers                                                *
 *  Author      : Colin Pearce, Active Silicon Ltd                        *
 *  Systems     : ANSI C                                                  *
 *  Written     : February 1996                                           *
 *  Updated     : 21-Feb-96                                               *
 *  Version     : 3.20                                                    *
 *                                                                        *
 *  Copyright (c) 1996 Active Silicon, Active Imaging Ltd.                *
 **************************************************************************
 * Comments:
 * This file is is used by the Snapper libraries and the various drivers
 * for different operating systems.
 */

#ifndef _fpga_h
#define _fpga_h

#define FPGA_MAX_NUM_FPGAS    100
#define FPGA_MAX_RBT_NAME_LEN  16

/*
 * FPGA Structure for info from "rbt2c"
 * ------------------------------------
 */
struct Tfpga_rbt2c {
   char Name[RBT_ASL_NAME_LENGTH];    /* e.g. "da0102sl.rbt"     */
   char *pDate;                       /* e.g. "10-Jan-96 10:33"  */
   ui32 BitLength;                    /* bit length of FPGA data */
   ui8  *pData;                       /* pointer to FPGA data    */
};

#endif /* _fpga_h */

