/**************************************************************************
 *                ACTIVE SILICON LIMITED / DATA CELL LIMITED              * 
 *                                                                        *
 *  File name   : sbus_drv.h                                              *
 *  Function    : Header file for SBus Bus Interface Board - driver level *
 *  Project     : Snapper SBus Bus Interface Board                        *
 *  Author      : Chris Beynon        UNIX C                              *
 *  Systems     : Solaris 2 (ANSI C)                                      *
 *  Written     : 30-Aug-94                                               *
 *  Updated     : 02-Sep-94                                               *
 *  Version     : 2.6                                                     *
 *                                                                        *
 *  Copyright (c) 1994, 1995 Active Silicon Ltd, Data Cell Ltd.           *
 **************************************************************************
 *  Comments:
 *  SOL1 & SOL2 in comments flag differences between Solaris 1 & 2
 */

#ifndef _sbus_drv_h
#define _sbus_drv_h


/* FUNCTION PROTOTYPES (in alphabetical order)
 * -------------------------------------------
 */
Tboolean EXPORT_FN SBUS_8051_busy(Thandle);
ui32 EXPORT_FN SBUS_8051_read_ui32(Thandle, ui32);
Terr EXPORT_FN SBUS_8051_command(Thandle, ui8);
void EXPORT_FN SBUS_8051_write_ui32(Thandle, ui32, ui32);
Terr EXPORT_FN SBUS_configure_fpga(Thandle, struct Tfpga_info *);
void EXPORT_FN SBUS_fpga_3000_data( Thandle, ui8, struct Tfpga_info *);
Tboolean EXPORT_FN SBUS_is_fpga_configured(Thandle, struct Tfpga_info *);
void EXPORT_FN SBUS_map_slot();
ui32 EXPORT_FN SBUS_read_ui32(Thandle, ui32);
Terr EXPORT_FN SBUS_reset_fpga(Thandle, struct Tfpga_info *);
void EXPORT_FN SBUS_write_ui32(Thandle, ui32, ui32);

#endif /* _sbus_drv_h */

