/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : snp_rev.h                                               *
 *  Function    : Snapper Revision Level Information                      *
 *  Project     : Snappers                                                *
 *  Authors     : Martin Bone ; ASL                                       *
 *  Systems     : ANSI C                                                  *
 *  Written     : May 1999                                                *
 *  Updated     :                                                         *
 *                                                                        *
 *  Copyright (c) 1993-99 Active Silicon Ltd, Active Imaging Ltd.         *
 **************************************************************************
 * Comments:
 */


#ifndef _snp_rev_h
#define _snp_rev_h

#define SNP_REV_LEVEL_MAJOR      4
#define SNP_REV_LEVEL_MINOR      1
#define SNP_REV_LEVEL_SUB_MINOR  25
#define SNP_REV_STAGE            0

#define SNP_REV_LEVEL    ((SNP_REV_LEVEL_MAJOR*10000)+(SNP_REV_LEVEL_MINOR*100)+(SNP_REV_LEVEL_SUB_MINOR))
#define SNP_REV_STRING   "4.01.25"

/* Release History
 * ===============
 *
 Release  : 4.01.25
 Date     : 25-June-2002
 OS       : MacOS X
 Remarks  : Added control flag to Dig16_set_ROI to avoid minimal ROI rounding up
 
 Release  : 4.01.24
 Date     : 11-June-2002
 OS       : MacOS X
 Remarks  : Fixed capture status/capture complete interaction with OS_ReadComplete
 
 Release  : 4.01.23
 Date     : 19-Jun-2002
 OS       : All
 Remarks  : Added _MINIMAL_TMG #define (default is NOT defined, ie link with full TMG library).
            Used to remove all calls to the extended TMG library features, ie LUT manipulation, JPEG codecs, etc
          : Fixed LWP leak problem in BASE_create/BASE_destroy
 
 Release  : 4.01.22
 Date     : 7-May-2002
 OS       : MacOS X
 Remarks  : Fixed library/driver interaction on capure abort.
 
 Release  : 4.01.21
 Date     : 26-Apr-2002
 OS       : MacOS X
 Remarks  : Added timeout support for AMCC bug workaround. Fixed multiple open bug.
 
 Release  : 4.01.20
 Date     : 19-Feb-2002
 OS       : MacOS 9
 Remarks  : Added timeout support for AMCC bug workaround
 
 Release  : 4.01.19
 Date     : 7-Feb-2002
 OS       : MacOS 9
 Remarks  : Workaround in DRV_DMA_Abort for AMCC bug
 
 Release  : 4.01.18
 Date     : 30-May-2001
 OS       : MacOS X
 Remarks  : First MacOS X port
 
 Release  : 4.01.17
 Date     : 7-Feb-2001
 OS       : VxWorks
 Remarks  : Added variable _SnapperVxWorksTaskSpawnOptions. Used -mlongcall compilation option
 
 Release  : 4.01.16
 Date     : 1-Nov-2000
 OS       : Windows2000/NT4
 Remarks  : Fixed problem whereby DMA and PhysMem_Lock were limited to 64MBytes
 
 Release  : 4.01.15
 Date     : 26-Sep-2000
 OS       : Windows2000
 Remarks  : Fixed interrupt loading on multiprocessor machines (HalAssignSlotResources)
 
 Release  : 4.01.14
 Date     : 07-Jul-2000
 OS       : MacOS8
 Remarks  : Fixed driver load time memory sizing problem
 
 Release  : 4.01.13
 Date     : 29-Jun-2000
 OS       : MacOS8
 Remarks  : Reduced interrupts latencies
 
 Release  : 4.01.12
 Date     : 27-Jun-2000
 OS       : Solaris
 Remarks  : VxWorks PPC release
 
 Release  : 4.01.11
 Date     : 24-May-2000
 OS       : Solaris
 Remarks  : Fixed linescan problems under Solaris
 
 Release  : 4.01.10
 Date     : 18-May-2000
 OS       : MacOS
 Remarks  : Discovered IEEE1275 /memory@0/available property to size RAM
 
 Release  : 4.01.09
 Date     : 11-May-2000
 OS       : MacOS
 Remarks  : Removed Gestalt call from driver - DMA max set to 512MBytes
 
 Release  : 4.01.08
 Date     : 11-Apr-2000
 OS       : WinNT
 Remarks  : OS_InterruptThread modified to use BASE_get_parameter to determine the module family.
 
 Release  : 4.01.07
 Date     : 9-Mar-2000
 OS       : MacOS
 Remarks  : DIG16_generate_timer_pulse modified to use START_AND RETURN on BASE_timer function

 Release  : 4.01.06
 Date     : 25-Feb-2000
 OS       : MacOS
 Remarks  : Modified algorithm to determine total memory installed.  Requires that InterfaceLib be included in the driver

 Release  : 4.01.05
 Date     : 14-Feb-2000
 OS       : MacOS
 Remarks  : DIG16_capture_to_image continues if DMA is successfully enabled, even if the DMA enable call timed out.

 Release  : 4.01.04
 Date     : 3-Dec-1999
 OS       : WinNT
 Remarks  : DIG16_START_AND_RETURN_IMMEDIATE added to DIG16_capture_to_image function.

 Release  : 4.01.03
 Date     : 9-Nov-1999
 OS       : WinNT
 Remarks  : DMA limit increased to 1GB

 Release  : 4.01.02
 Date     : 13-Oct-1999
 OS       : WinNT, Solaris source release
 Remarks  : WinNT driver build options - with or without IO timer for callbacks

 Release  : 4.01.01
 Date     : 8-Sep-1999
 OS       : Win95
 Remarks  : Number of TMG handles increased to 64K

 Release  : 4.01.00
 Date     : 16-Aug-1999
 OS       : Solaris 2.7
 Remarks  : Analogue Linescan Beta Release

 Release  : 4.00.00
 Date     : 4-May-1999
 OS       : WinNT, Win95, MacOS, LynxOS, VxWorks
 Remarks  : Major Release
 */

#endif /* _snp_rev_h */

