/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : tmg_old.h                                               *
 *  Function    : Prototype definitions for old TMG library functions     *
 *  Project     : Snappers                                                *
 *  Author      : Colin Pearce, Active Silicon Ltd                        *
 *  Systems     : ANSI C                                                  *
 *  Written     : Jul-95                                                  *
 *  Updated     : 15-Jan-96                                               *
 *  Version     : 3.10                                                    *
 *                                                                        *
 *  Copyright (c) 1993-96 Active Silicon, Active Imaging Ltd.             *
 **************************************************************************
 *  Comments:
 *  The functions in this file have been renamed as part of a naming 
 *  convention re-alignment.  To maintain compatibility with the old names,
 *  include this header file in your application and also compile in 
 *  tmg_old.c.  It is strongly recommended changing the application to use 
 *  the new names - they are far more structured and in-line with the latest
 *  documentation.
 */

#ifndef _TMG_OLD_H_
#define _TMG_OLD_H_

#define Tcrunch_handle Thandle

#define BASE_ALL         BASE_ALL_HANDLES
#define TMG_ALL          TMG_ALL_HANDLES
#define TMG_NULL_HANDLE  TMG_NULL


#ifdef __cplusplus
extern "C" {
#endif
/*
 * TMG_old.c - Compatible functions - old functions, now renamed in main lib.
 */
Terr     EXPORT_FN     TMG_build_jpeg_image(Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_build_jpeg_sequence(Thandle, Thandle);
Terr     EXPORT_FN     TMG_calculate_sequence_length(Thandle);
Terr     EXPORT_FN     TMG_calculate_total_strips(Thandle);
Terr     EXPORT_FN     TMG_check_image(Thandle);
Terr     EXPORT_FN     TMG_chroma_key(Thandle, Thandle, Thandle, ui16, Thandle, ui16, ui16);
Terr     EXPORT_FN     TMG_chroma_key_calibrate(Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_close_jpeg_file(Thandle);
Terr     EXPORT_FN     TMG_copy_cmap(Thandle, Thandle);
Terr     EXPORT_FN     TMG_copy_image(Thandle, Thandle);
Terr     EXPORT_FN     TMG_copy_image_parameters(Thandle, Thandle);
Thandle  EXPORT_FN     TMG_create_chroma_key(void);
Thandle  EXPORT_FN     TMG_create_display(void);
Thandle  EXPORT_FN     TMG_create_image(void);
Thandle  EXPORT_FN     TMG_create_jpeg_image(void);
Thandle  EXPORT_FN     TMG_create_lut(void);
Terr     EXPORT_FN     TMG_destroy_all(void);
Terr     EXPORT_FN     TMG_destroy_chroma_key(Thandle);
Terr     EXPORT_FN     TMG_destroy_display(Thandle);
Terr     EXPORT_FN     TMG_destroy_image(Thandle);
Terr     EXPORT_FN     TMG_destroy_lut(Thandle);
Terr     EXPORT_FN     TMG_destroy_YUV422_to_RGB8_LUT(void);
Terr     EXPORT_FN     TMG_extract_jpeg_frame(Thandle, Thandle, ui32);
ui8      EXPORT_FN     TMG_find_closest_colour(Thandle, ui8, ui8, ui8);
Terr     EXPORT_FN     TMG_find_file_format(char*);
Terr     EXPORT_FN     TMG_generate_cmap(Thandle, ui16, ui16);
Terr     EXPORT_FN     TMG_generate_YUV422_to_RGB8_LUT(Thandle);
Terr     EXPORT_FN     TMG_get_chroma_key_hue(Thandle);
Terr     EXPORT_FN     TMG_get_chroma_key_hue_tol(Thandle);
Terr     EXPORT_FN     TMG_get_chroma_key_luma(Thandle);
Terr     EXPORT_FN     TMG_get_chroma_key_luma_tol(Thandle);
ui32     EXPORT_FN     TMG_get_cmap_occurrences(Thandle, ui16);
CMAP_PTR EXPORT_FN_PTR TMG_get_colourmap_ptr(Thandle);
Terr     EXPORT_FN     TMG_get_data_width(Thandle);
Terr     EXPORT_FN     TMG_get_display_depth(Thandle);
Terr     EXPORT_FN     TMG_get_display_height(Thandle);
Terr     EXPORT_FN     TMG_get_display_type(Thandle);
Terr     EXPORT_FN     TMG_get_display_width(Thandle);
Tboolean EXPORT_FN     TMG_get_field_mode(Thandle);
Terr     EXPORT_FN     TMG_get_image_type(Thandle);
char FAR EXPORT_FN_PTR TMG_get_infilename(Thandle);
IM_UI8   EXPORT_FN_PTR TMG_get_jpeg_current_ptr(Thandle);
IM_UI8   EXPORT_FN_PTR TMG_get_jpeg_image_ptr(Thandle);
char FAR EXPORT_FN_PTR TMG_get_outfilename(Thandle);
struct Tjpeg  EXPORT_FN_PTR TMG_get_Pimage_Pjpeg_ptr(Thandle);
struct Timage EXPORT_FN_PTR TMG_get_Pimage_ptr(Thandle);
Terr     EXPORT_FN     TMG_get_flags(Thandle, ui32);
IM_UI8   EXPORT_FN_PTR TMG_get_image_ptr(Thandle);
Terr     EXPORT_FN     TMG_get_jpeg_data_size(Thandle);
ui8      EXPORT_FN_PTR TMG_get_lut_ptr(Thandle, ui16);
ui32     EXPORT_FN     TMG_get_YUV_values_RGB(ui16, ui16, ui16);
Tboolean EXPORT_FN     TMG_is_colour(Thandle);
Tboolean EXPORT_FN     TMG_is_colour_display(Thandle);
Tboolean EXPORT_FN     TMG_is_grayscale_cmap(Thandle);
Terr     EXPORT_FN     TMG_lut(Thandle, Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_malloc_jpeg_data(Thandle);
Terr     EXPORT_FN     TMG_malloc_N_bytes_jpeg_data(Thandle, ui32);
Terr     EXPORT_FN     TMG_make_lut(Thandle, i16, i16, i16, i16, i16, i16);
Terr     EXPORT_FN     TMG_move_image(Thandle, Thandle);
Terr     EXPORT_FN     TMG_open_jpeg_file(Thandle);
Terr     EXPORT_FN     TMG_pixel_rep(Thandle, Thandle, ui16, ui16);
Terr     EXPORT_FN     TMG_read_image(Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_read_jpeg_file(Thandle);
Terr     EXPORT_FN     TMG_read_targa_file(Thandle, ui16);
Terr     EXPORT_FN     TMG_RGB16_Y8_to_paletted_LUT(Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_sequence_set_start_frame(Thandle, ui32);
Terr     EXPORT_FN     TMG_set_chroma_key_hue(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_chroma_key_hue_tol(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_chroma_key_luma(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_chroma_key_luma_tol(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_cmap(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_cmap_size(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_colour(Thandle, ui16, ui16);
Terr     EXPORT_FN     TMG_set_current_frame(Thandle, ui32);
Terr     EXPORT_FN     TMG_set_data_width(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_depth(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_display_depth(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_display_height(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_display_type(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_display_width(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_field_mode(Thandle, Tboolean);
Terr     EXPORT_FN     TMG_set_height(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_image_type(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_image_ptr(Thandle, IM_UI8*);
Terr     EXPORT_FN     TMG_set_infilename(Thandle, char*);
Terr     EXPORT_FN     TMG_set_jpeg(Thandle, Thandle);
Terr     EXPORT_FN     TMG_set_jpeg_current_ptr(Thandle, IM_UI8*);
Terr     EXPORT_FN     TMG_set_jpeg_data_size(Thandle, ui32);
Terr     EXPORT_FN     TMG_set_jpeg_image_ptr(Thandle, IM_UI8*);
Terr     EXPORT_FN     TMG_set_lines_this_strip(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_no_of_frames(Thandle, ui32);
Terr     EXPORT_FN     TMG_set_outfilename(Thandle, char*);
Terr     EXPORT_FN     TMG_set_RGB_colour(Thandle, ui16, ui8, ui8, ui8);
Terr     EXPORT_FN     TMG_set_width(Thandle, ui16);
Terr     EXPORT_FN     TMG_subsample(Thandle, Thandle, ui16, ui16);
Terr     EXPORT_FN     TMG_to_paletted(Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_write_image(Thandle, Thandle, ui16);
Terr     EXPORT_FN     TMG_write_jpeg_file(Thandle, ui16);
Terr     EXPORT_FN     TMG_write_targa_file(Thandle, ui16);
Terr     EXPORT_FN     TMG_YUV422_to_RGB8_LUT(Thandle, Thandle, ui16);

#if defined _DOS
Terr     EXPORT_FN     TMG_clear_display(Tdisplay_handle);
Terr     EXPORT_FN     TMG_display_image_abs(Tdisplay_handle, Timage_handle, ui16, ui16, ui16);
Terr     EXPORT_FN     TMG_DOS_display(Thandle);
Terr     EXPORT_FN     TMG_fill_box(Tdisplay_handle, ui16, ui16, ui16, ui16, ui16);
Terr     EXPORT_FN     TMG_set_font_6x7(Tdisplay_handle);
Terr     EXPORT_FN     TMG_set_font_8x8(Tdisplay_handle);
Terr     EXPORT_FN     TMG_set_font_8x14(Tdisplay_handle);
Terr     EXPORT_FN     TMG_set_font_8x16(Tdisplay_handle);
Terr     EXPORT_FN     TMG_set_font_15x19(Tdisplay_handle);
Terr     EXPORT_FN     TMG_write_display_cmap(Tdisplay_handle, Thandle);
Terr     EXPORT_FN     TMG_write_text(Thandle, char*, ui16, ui16);
#endif

#if defined _X_GRAPHICS
Terr     EXPORT_FN     TMG_associate_Xcmap(Thandle);
Terr     EXPORT_FN     TMG_init_display(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_XidDisplay(Thandle, Window);
Terr     EXPORT_FN     TMG_set_XidFrame(Thandle, Window);
Terr     EXPORT_FN     TMG_set_XidCanvas(Thandle, Window);
Terr     EXPORT_FN     TMG_set_XReservedColours(Thandle, ui16);
Terr     EXPORT_FN     TMG_get_XReservedColours(Thandle);
#endif  /* _X_GRAPHICS */

#if defined _WINDOWS && defined _WIN31
Terr     EXPORT_FN     TMG_get_DeviceCaps(Thandle, ui16);
Terr     EXPORT_FN     TMG_set_DeviceCaps(Thandle, ui16, ui16);
Terr     EXPORT_FN     TMG_init_display(Thandle, HWND);
Terr     EXPORT_FN     TMG_set_flags(Thandle, ui32, Tboolean);
Terr     EXPORT_FN     TMG_set_flags_all(ui32, Tboolean);
Terr     EXPORT_FN     TMG_set_hWnd(Thandle, HWND);
Terr     EXPORT_FN     TMG_set_paint_hDC(Thandle, HDC);
HWND     EXPORT_FN     TMG_get_hWnd(Thandle);
HDC      EXPORT_FN     TMG_get_paint_hDC(Thandle);
#endif  /* _WIN31 */

#ifdef _DOS
Terr     EXPORT_FN     TMG_init_display(Thandle, ui16);
#endif

#ifndef _WIN31
/* 
 * Note due to the _pascal calling convention used under Windows 3.1, 
 * the following should not be defined under Windows 3.1 compilations.
 * (i.e. under Windows the files below are __export).
 */
Terr EXPORT_FN TMG_write_tiff_file(Thandle, ui16);
Terr EXPORT_FN TMG_read_tiff_file(Thandle, ui16);
Terr EXPORT_FN TMG_write_eps_file(Thandle, ui16);
Terr EXPORT_FN TMG_read_eps_file(Thandle, ui16);
#endif

#ifdef __cplusplus
};
#endif

#endif  /* _TMG_OLD_H_ */
