/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : w31ioctl.h                                              *
 *  Function    : Definitions for Windows 3.1 Device I/O driver calls     *
 *                when used under Windows 95 using the Windows 95 VxD.    *
 *  Project     : Snappers                                                *
 *  Author      : Colin Pearce, Active Silicon Ltd                        *
 *  Systems     : ANSI C                                                  *
 *  Written     : 07-Aug-96                                               *
 *  Updated     : 07-Aug-96                                               *
 *  Version     : 3.1?                                                    *
 *                                                                        *
 *  Copyright (c) 1996 Active Silicon, Active Imaging Ltd.                *
 **************************************************************************
 *  Comments:
 */

#ifndef _w31ioctl_h
#define _w31ioctl_h

/*
 * IOCTL Codes
 * -----------
 * The notes indicate which ioctls are supported using the Windows 95 VxD.
 */
#define IOCTL16_SNAPPER_OPEN_DEVICE       0x301   /* Done, tested */
/* Win31 also needs a close */
#define IOCTL16_SNAPPER_CLOSE_DEVICE      0x311   /* Done, tested */
#define IOCTL16_SNAPPER_WRITE_UI8         0x302   /* Done */
#define IOCTL16_SNAPPER_READ_UI8          0x303   /* Done, tested */
#define IOCTL16_SNAPPER_WRITE_UI16        0x304   /* Done */
#define IOCTL16_SNAPPER_READ_UI16         0x305   /* Done */
#define IOCTL16_SNAPPER_WRITE_UI32        0x306   /* Done, tested */
#define IOCTL16_SNAPPER_READ_UI32         0x307   /* Done, tested */
#define IOCTL16_SNAPPER_DYLAN_WRITE_UI32  0x308   /* Done, tested */
#define IOCTL16_SNAPPER_DYLAN_READ_UI32   0x309   /* Done, tested? */
#define IOCTL16_SNAPPER_FPGA_SEND_INFO    0x30A   /* Done, tested? */
#define IOCTL16_SNAPPER_FPGA_SEND_DATA    0x30B   /* Done, tested */
#define IOCTL16_SNAPPER_FPGA_RESET        0x30C   /* Done, tested? */
#define IOCTL16_SNAPPER_FPGA_GET_CONFIG_STATUS 0x30D  /* Done, tested? */
#define IOCTL16_SNAPPER_BURST_IN_UI16     0x30E
#define IOCTL16_SNAPPER_BURST_IN_UI32     0x30F   /* Done, tested */
#define IOCTL16_SNAPPER_BURST_IN_UI32_ASYNC 0x31F   /* Done, tested */
#define IOCTL16_IS_ASYNC_DMA_COMPLETE     0x32F     /* Done, tested */
#define IOCTL16_SNAPPER_BURST_IN_UI16_SPECIAL  0x310
#define IOCTL16_SNAPPER_BURST_OUT_UI16    0x311
#define IOCTL16_SNAPPER_TABLE_LOAD        0x312   /* Done */
#define IOCTL16_SNAPPER_PAGE_WRITE_UI16   0x313
#define IOCTL16_SNAPPER_BURST_OUT_UI16_SPECIAL 0x314
#define IOCTL16_SNAPPER_GET_ERROR_STRING  0x315
#define IOCTL16_SNAPPER_ABORT_OPERATION   0x316   /* Done */
#define IOCTL16_SNAPPER_TIMEOUT_SET       0x317   /* Done, tested */
#define IOCTL16_SNAPPER_SERIAL_TX         0x318   /* Done, tested */
#define IOCTL16_SNAPPER_SERIAL_RX         0x319   /* Done */
#define IOCTL16_SNAPPER_SERIAL_SEND_INFO  0x320   /* Done */
#define IOCTL16_SNAPPER_SERIAL_GET_INFO   0x321   /* Done */
#define IOCTL16_SNAPPER_INTERRUPT_SET     0x322   /* Done */
#define IOCTL16_SNAPPER_GETTIMESTAMP      0x323   /* Done, not tested/used */

#endif  /* _w31ioctl_h */
