/**************************************************************************
 *                ACTIVE SILICON LIMITED / ACTIVE IMAGING LIMITED         *
 *                                                                        *
 *  File name   : xlibstub.h                                              *
 *  Function    : Definitions for X11 stub library                        *
 *  Project     : Snapper                                                 *
 *  Author      : MH, Active Silicon Ltd                                  *
 *  Systems     : ANSI C                                                  *
 *  Written     : October 1998                                            *
 *  Updated     : 27-Oct-98                                               *
 *  Version     : 1.00.01                                                 *
 *                                                                        *
 *  Copyright (c) 1998 Active Silicon, Active Imaging Ltd.                *
 **************************************************************************
 *  Comments:
 *  File of dummy data structures and function definitions to stub out 
 *  X-graphics calls implicit in the Snapper and TMG libraries 
 *  for apps where imaging is not required.
 *  This is to avoid the necessity of providing two sets of libraries, 
 *  one with display capability and one without.
 *  To build applications using the libraries and stubbing-out X-graphics, 
 *  link with the libX11.a library in the Snapper library directory.
 */

/* Data definitions for stub arguments */

typedef ui32 XID;
typedef XID Colormap;
typedef XID Window;
typedef XID KeySym;
typedef XID Font;
typedef XID Drawable;
typedef int Status;
typedef int Bool;
typedef XID GC;
typedef char* caddr_t;
//typedef struct xlibstub_GC                { int dummy; } GC;
typedef struct xlibstub_Display           { int dummy; } Display; 
typedef struct xlibstub_XGCValues         { int dummy; } XGCValues;
typedef struct xlibstub_Visual            { int dummy; } Visual;
typedef struct xlibstub_XWindowAttributes { int dummy; } XWindowAttributes;
typedef struct xlibstub_VisualInfo        { int dummy; } XVisualInfo;
typedef struct xlibstub_XImage            { int dummy; } XImage;
typedef struct xlibstub_XEvent            { int dummy; } XEvent;
typedef struct xlibstub_XKeyEvent         { int dummy; } XKeyEvent;
typedef struct xlibstub_XKeySym           { int dummy; } XKeysym; 
typedef struct xlibstub_XComposeStatus    { int dummy; } XComposeStatus;
typedef struct xlibstub_XColor            { int dummy; } XColor;
typedef struct xlibstub_XFontStruct       { int dummy; } XFontStruct;
typedef struct xlibstub_XTextProperty     { int dummy; } XTextProperty;
typedef struct xlibstub_XWMHints          { int dummy; } XWMHints;
typedef struct xlibstub_XSizeHints        { int dummy; } XSizeHints;
typedef struct xlibstub_XClassHints       { int dummy; } XClassHint;

/* Function Declarations */
Status 	XAllocColorCells( Display*, Colormap, Bool, unsigned long int, 
                          unsigned int, unsigned long int, unsigned int );
void   	XClearWindow( Display*, Window );
void   	XCloseDisplay( Display* );
void   	XCreateColormap( Display*, Window, Visual*, int );
GC     	XCreateGC( Display*, Drawable, unsigned long int, XGCValues* );
XImage* XCreateImage( Display*, Visual*, unsigned int, int, int, char*, 
                             unsigned int, unsigned int, int, int );
Window  XCreateSimpleWindow( Display*, Window, int, int, unsigned int, 
                             unsigned int, unsigned int, unsigned long int, 
                             unsigned long int );
char*   XDisplayName( char* );
void    XDrawString( Display*, Drawable, GC, int, int, char*, int );
int     XEventsQueued( Display* , int );
void    XFlush( Display* );
void    XFree( caddr_t );
void    XFreeColormap( Display* display, Colormap cmap );
void    XFreeColors( Display*, Colormap, unsigned long int*, int, 
                      unsigned long int );
void    XFreeGC( Display*, GC );
XVisualInfo* XGetVisualInfo( Display*, long int, XVisualInfo*, int* );
Status  XGetWindowAttributes( Display*, Window, XWindowAttributes* );
XFontStruct* XLoadQueryFont( Display*, char* );
int     XLookupString( XKeyEvent*, char*, int, KeySym*, XComposeStatus );
void    XMapWindow( Display*, Window );
void    XNextEvent( Display*, XEvent* );
Display* XOpenDisplay( char* );
void    XPutImage( Display*, Drawable, GC, XImage*, int, int, int, int, 
                   unsigned int, unsigned int  );
void    XQueryColors( Display*, Colormap, XColor*, int );
void    XSelectInput( Display*, Window, long int );
void    XSetDashes( Display*, GC, int, char*, int );
void    XSetFont( Display*, GC, Font );
void    XSetForeground( Display*, GC, unsigned long int );
void    XSetLineAttributes( Display*, GC, unsigned int, int, int, int );
void    XSetWMProperties( Display*, Window, XTextProperty*, XTextProperty*, 
                          char**, int, XSizeHints*, XWMHints*, XClassHint* );
void    XSetWindowColormap( Display*, Window, Colormap );
void    XStoreColors( Display*, Colormap, XColor*, int );
Status  XStringListToTextProperty( char**, int, XTextProperty* );
int     XTextWidth( XFontStruct*, char*, int );
void    XUnloadFont( Display*, Font );
