/*************************************************************************
 *                          ACTIVE SILICON LIMITED                        
 *
 *  File name   : xpl_pro.h
 *  Project     : ASLexamp core example code Prototypes Module
 *  Author      : Martin Bone
 *  Systems     : ANSI C, WIN32, X, DOS
 *  Written     : 24-FEB-1998
 *  Updated     : 
 *  Version     : 1:00:00                                                     
 *                                                                        
 *  Copyright   : Active Silicon 1998
 **************************************************************************
 * Comments: Header file for all prototypes
 *
 * Assumptions:
 * Revisions:
 */

/*  XPL_DBG
 */
extern void DBG_WriteString (ui32, char *, ...);
extern void DBG_Open ( char * );
extern void DBG_Close ( void );

/* XPL_GUI
 */
/* Only for the MAC - to obtain on-screen debugging output */
void MAC_err_display( char* fn_name, Terr problem, char* description );

extern ui32 GUI_CheckMessageQueue( struct GuiInfo *psGui, struct Event **pseEvent );
extern ui32 GUI_DisplayInit      ( struct GuiInfo *psGui );
extern ui32 GUI_DisplayImage     ( struct GuiInfo *psGui, ui32 dwBufferNumber );
extern ui32 GUI_DisplayClose     ( struct GuiInfo *psGui );
extern ui32 GUI_DisplayInitInfo  ( struct GuiInfo *psGui, char *pszProgName );
extern ui32 GUI_DisplayReSize    ( struct GuiInfo *psGui );

extern ui32 GUI_SetCmdParams     ( struct Info *psInfo, ui16 argc, char **argv );

extern ui32 GUI_DebugOpen ( struct GuiInfo *psGui );
extern ui32 GUI_DebugClose( struct GuiInfo *psGui );
extern ui32 GUI_DebugWriteString( struct GuiInfo *psGui, ui32 dwDebugLevel, char *szFormat, ...);

extern ui32 GUI_SnapInit( struct SnapInfo* psSnap );

/* OS-independent TMG image structure init function declaration*/
extern ui32 GUI_TmgClose         ( struct GuiInfo *psGui );
extern ui32 GUI_TmgInit          ( struct GuiInfo *psGui );
extern ui32 GUI_TmgGetImage      ( struct GuiInfo *psGui, ui32 dwImageNumber );
extern ui32 GUI_TmgGetImageFull  ( struct GuiInfo *psGui, ui32 dwFrameBufferNumber, ui32 *pbFull );
extern ui32 GUI_TmgSetImageFull  ( struct GuiInfo *psGui, ui32 dwFrameBufferNumber, ui32 bFull );
extern ui32 GUI_TmgWriteFile     ( struct GuiInfo *psGui, char *szFileBase, ui32 dwFileFormat, ui32 dwHandleIndex );

/* OS-independent Command line parsing utility */
extern ui32 ASL_ParseCmdLine( struct Cmd *psCmd, i16 argc, char** argv);
extern ui32 ASL_Sleep(ui32 dwMicroSeconds );

extern void GUI_EnableErrorHandler( Tboolean Enable );
extern void GUI_DisplayRates( struct Info *psInfo );


/* XPL_MISC
 */
extern Terr ConfigXillixPmi1400 ( struct Info *psInfo );
extern Terr TimerFnXillixPmi1400 ( Thandle hDig16 );

extern Terr HistogramImage ( Thandle hImage );

/* XPL_SEM
 */
extern ui32 ASL_Sem_Destroy( struct SemInfo *psSemInfo );
extern ui32 ASL_Sem_Create( struct SemInfo *psSemInfo, ui32 dwInitialCount, ui32 dwMaximumCount );
extern ui32 ASL_Sem_Signal( struct SemInfo *psSemInfo, ui32 dwCount );
extern ui32 ASL_Sem_WaitWithTimeout( struct SemInfo *psSemInfo, ui32 dwWait );
extern ui32 ASL_Sem_SaveParent( struct SemInfo *psParentSemInfo, struct SemInfo *psChildSemInfo );
extern ui32 ASL_Sem_SignalParent( struct SemInfo *psSemInfo, ui32 dwCount );


/* XPL_THRD
 */
extern ui32 ASL_Thrd_Gettime( double* dTime );
extern ui32 ASL_Thrd_Create( struct ThrdInfo *psThrdInfo, void *pfFunction, void* pArg, ui32 dwPriority );
extern ui32 ASL_Thrd_Delete( struct ThrdInfo *psThrdInfo );
