/*************************************************************************
 *                          ACTIVE SILICON LIMITED                      
 *  File name   : xpl_sem.h
 *  Project     : ASLEXAMP maintained Snapper example code header file
 *  Author      : Mike Harrison, Martin Bone
 *  Systems     : ANSI C, TRUE POSIX & WIN32 threading.
 *  Written     : 4-MAR-1998
 *  Updated     : 
 *  Version     : 1:00:00                                                 
 *                                                                        
 *  Copyright 
 **************************************************************************
 * Comments: 
 * Assumptions:
 * Revisions:
 */
#if ! defined _XPL_SEM_DEFINED
#define _XPL_SEM_DEFINED

/* OS-dependent thread/semaphore mechanisms */
struct SemInfo
{
/* Thread mechanisms */
#if defined _WINNT || defined _WIN95
HANDLE hSem;             /* Semaphore owned by this thread */
HANDLE hParentSem;       /* Semaphore owned by parent- used for signalling to the parent */
 
#elif defined _LYNXOS || _SOLARIS2 || _LINUX
/* Semaphores local to Thread - use conditional variables because under POSIX 
   these are the only semaphores with timeout signalling.
*/
pthread_mutexattr_t ptmaSemAttr;
pthread_mutex_t     ptmSem;
pthread_condattr_t  pcaCondAttr; 
pthread_cond_t      pcCondVar;

/* For the main process to signal to the threads */
pthread_cond_t*     ppcParentCondVar;
pthread_mutex_t*    pptmParentSem;

#elif defined _MACINTOSH
ui32 dwSemaCallbackDone;

#else 
/*#error No thread mechanism defined - due to no OS defined ! */
#endif
};


#endif
