#!/bin/bash
cd 2.4-kernel-progs/apps/$1

# is X installed? If not, not a lot of point in
# trying to run]
which xinit
# check the return code
RETCODE=$?
if [ "$RETCODE" != "0" ]; then
  echo "X Windows is not installed on this system"
  read key
  exit;
fi

if [ ! -e /tmp/.X0-lock ]; then # doesn't look as if X is running
  echo "X Windows doesn't seem to be running"
  read key
  exit;
fi

# is the Snapper driver loaded? If not, apps will fail to init so we will warn

grep snp /proc/modules
RETCODE=$?
if [ "$RETCODE" != "0" ]; then
  echo "The Snapper driver doesn't seem to be loaded."
  echo ""
  echo "Press any key to continue"
  read key
fi


# are we running as root? If we su'd to there using a normal
# X console then root will not be able to grab the screen, so
# we might need to find out what the original user name was,
# su back to that, THEN launch livewin,
if [ "$UID" = "0" ]; then
  echo "you are running as root"
  echo "I will now try and run the command as the first logged in user"
  echo "Hopefully that is you, before you su'd as root to run this installer"
  echo ""
  echo "Press Q to exit the application"
  # find out who the other users are by running 'users' command
  # awk it and take the first one we find
  # use su to run livewin as that user
  su `users | awk '{print $1}'` -c ./$1
  read key
else
  echo "Press Q to exit the application"
  ./$1
  read key
fi
